/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 1036:  /* *plus_carry_in_dpp_shr_v64si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3));
      break;

    case 1037:  /* *plus_carry_dpp_shr_v64di */
    case 1035:  /* *plus_carry_dpp_shr_v64si */
    case 1034:  /* *plus_carry_dpp_shr_v64hi */
    case 1033:  /* *plus_carry_dpp_shr_v64qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 1032:  /* *xor_dpp_shr_v64di */
    case 1031:  /* *ior_dpp_shr_v64di */
    case 1030:  /* *and_dpp_shr_v64di */
    case 1029:  /* *plus_dpp_shr_v64di */
    case 1028:  /* *xor_dpp_shr_v64sf */
    case 1027:  /* *ior_dpp_shr_v64sf */
    case 1026:  /* *and_dpp_shr_v64sf */
    case 1025:  /* *plus_dpp_shr_v64sf */
    case 1024:  /* *umax_dpp_shr_v64sf */
    case 1023:  /* *umin_dpp_shr_v64sf */
    case 1022:  /* *smax_dpp_shr_v64sf */
    case 1021:  /* *smin_dpp_shr_v64sf */
    case 1020:  /* *xor_dpp_shr_v64hf */
    case 1019:  /* *ior_dpp_shr_v64hf */
    case 1018:  /* *and_dpp_shr_v64hf */
    case 1017:  /* *plus_dpp_shr_v64hf */
    case 1016:  /* *umax_dpp_shr_v64hf */
    case 1015:  /* *umin_dpp_shr_v64hf */
    case 1014:  /* *smax_dpp_shr_v64hf */
    case 1013:  /* *smin_dpp_shr_v64hf */
    case 1012:  /* *xor_dpp_shr_v64si */
    case 1011:  /* *ior_dpp_shr_v64si */
    case 1010:  /* *and_dpp_shr_v64si */
    case 1009:  /* *plus_dpp_shr_v64si */
    case 1008:  /* *umax_dpp_shr_v64si */
    case 1007:  /* *umin_dpp_shr_v64si */
    case 1006:  /* *smax_dpp_shr_v64si */
    case 1005:  /* *smin_dpp_shr_v64si */
    case 1004:  /* *xor_dpp_shr_v64hi */
    case 1003:  /* *ior_dpp_shr_v64hi */
    case 1002:  /* *and_dpp_shr_v64hi */
    case 1001:  /* *plus_dpp_shr_v64hi */
    case 1000:  /* *umax_dpp_shr_v64hi */
    case 999:  /* *umin_dpp_shr_v64hi */
    case 998:  /* *smax_dpp_shr_v64hi */
    case 997:  /* *smin_dpp_shr_v64hi */
    case 996:  /* *xor_dpp_shr_v64qi */
    case 995:  /* *ior_dpp_shr_v64qi */
    case 994:  /* *and_dpp_shr_v64qi */
    case 993:  /* *plus_dpp_shr_v64qi */
    case 992:  /* *umax_dpp_shr_v64qi */
    case 991:  /* *umin_dpp_shr_v64qi */
    case 990:  /* *smax_dpp_shr_v64qi */
    case 989:  /* *smin_dpp_shr_v64qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 988:  /* vec_cmpv64dfdi_dup_exec */
    case 987:  /* vec_cmpv64didi_dup_exec */
    case 986:  /* vec_cmpv64sfdi_dup_exec */
    case 985:  /* vec_cmpv64sidi_dup_exec */
    case 984:  /* vec_cmpv64hfdi_dup_exec */
    case 983:  /* vec_cmpv64hidi_dup_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 982:  /* vec_cmpv64dfdi_dup */
    case 981:  /* vec_cmpv64didi_dup */
    case 980:  /* vec_cmpv64sfdi_dup */
    case 979:  /* vec_cmpv64sidi_dup */
    case 978:  /* vec_cmpv64hfdi_dup */
    case 977:  /* vec_cmpv64hidi_dup */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 976:  /* vec_cmpv64dfdi_exec */
    case 975:  /* vec_cmpv64didi_exec */
    case 974:  /* vec_cmpv64sfdi_exec */
    case 973:  /* vec_cmpv64sidi_exec */
    case 972:  /* vec_cmpv64hfdi_exec */
    case 971:  /* vec_cmpv64hidi_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 970:  /* vec_cmpv64dfdi */
    case 969:  /* vec_cmpv64didi */
    case 968:  /* vec_cmpv64sfdi */
    case 967:  /* vec_cmpv64sidi */
    case 966:  /* vec_cmpv64hfdi */
    case 965:  /* vec_cmpv64hidi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 487:  /* recipv64df2_exec */
    case 485:  /* recipv64sf2_exec */
    case 483:  /* recipv64hf2_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 475:  /* fmav64df4_negop2_exec */
    case 473:  /* fmav64sf4_negop2_exec */
    case 471:  /* fmav64hf4_negop2_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 481:  /* fmadf4_negop2 */
    case 480:  /* fmasf4_negop2 */
    case 479:  /* fmahf4_negop2 */
    case 474:  /* fmav64df4_negop2 */
    case 472:  /* fmav64sf4_negop2 */
    case 470:  /* fmav64hf4_negop2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 469:  /* fmav64df4_exec */
    case 467:  /* fmav64sf4_exec */
    case 465:  /* fmav64hf4_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 478:  /* fmadf4 */
    case 477:  /* fmasf4 */
    case 476:  /* fmahf4 */
    case 468:  /* fmav64df4 */
    case 466:  /* fmav64sf4 */
    case 464:  /* fmav64hf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 336:  /* mulv64di3_zext_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 335:  /* mulv64di3_zext */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 334:  /* mulv64di3_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 380:  /* ashrv64si3_exec */
    case 378:  /* lshrv64si3_exec */
    case 376:  /* ashlv64si3_exec */
    case 332:  /* mulv64si3_dup_exec */
    case 330:  /* mulv64hi3_dup_exec */
    case 328:  /* mulv64qi3_dup_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 379:  /* ashrv64si3 */
    case 377:  /* lshrv64si3 */
    case 375:  /* ashlv64si3 */
    case 331:  /* mulv64si3_dup */
    case 329:  /* mulv64hi3_dup */
    case 327:  /* mulv64qi3_dup */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 320:  /* umulv64si3_highpart_exec */
    case 318:  /* smulv64si3_highpart_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 313:  /* subrv64di3_ds_exec */
    case 311:  /* subrv64sf3_ds_exec */
    case 309:  /* subrv64si3_ds_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 316:  /* subrdi3_ds_scalar */
    case 315:  /* subrsf3_ds_scalar */
    case 314:  /* subrsi3_ds_scalar */
    case 312:  /* subrv64di3_ds */
    case 310:  /* subrv64sf3_ds */
    case 308:  /* subrv64si3_ds */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 437:  /* subv64sf3_exec */
    case 435:  /* subv64hf3_exec */
    case 421:  /* smaxv64df3_exec */
    case 419:  /* sminv64df3_exec */
    case 417:  /* mulv64df3_exec */
    case 415:  /* addv64df3_exec */
    case 413:  /* smaxv64sf3_exec */
    case 411:  /* sminv64sf3_exec */
    case 409:  /* mulv64sf3_exec */
    case 407:  /* addv64sf3_exec */
    case 405:  /* smaxv64hf3_exec */
    case 403:  /* sminv64hf3_exec */
    case 401:  /* mulv64hf3_exec */
    case 399:  /* addv64hf3_exec */
    case 396:  /* subv64df3_exec */
    case 394:  /* umaxv64si3_exec */
    case 392:  /* uminv64si3_exec */
    case 390:  /* smaxv64si3_exec */
    case 388:  /* sminv64si3_exec */
    case 386:  /* vashrv64si3_exec */
    case 384:  /* vlshrv64si3_exec */
    case 382:  /* vashlv64si3_exec */
    case 374:  /* xorv64di3_exec */
    case 373:  /* iorv64di3_exec */
    case 372:  /* andv64di3_exec */
    case 368:  /* xorv64si3_exec */
    case 366:  /* iorv64si3_exec */
    case 364:  /* andv64si3_exec */
    case 362:  /* xorv64hi3_exec */
    case 360:  /* iorv64hi3_exec */
    case 358:  /* andv64hi3_exec */
    case 356:  /* xorv64qi3_exec */
    case 354:  /* iorv64qi3_exec */
    case 352:  /* andv64qi3_exec */
    case 326:  /* mulv64si3_exec */
    case 324:  /* mulv64hi3_exec */
    case 322:  /* mulv64qi3_exec */
    case 304:  /* subv64di3_ds_exec */
    case 302:  /* subv64sf3_ds_exec */
    case 300:  /* subv64si3_ds_exec */
    case 295:  /* addv64di3_ds_exec */
    case 293:  /* addv64sf3_ds_exec */
    case 291:  /* addv64si3_ds_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 439:  /* subsf3 */
    case 438:  /* subhf3 */
    case 436:  /* subv64sf3 */
    case 434:  /* subv64hf3 */
    case 433:  /* smaxdf3 */
    case 432:  /* smindf3 */
    case 431:  /* muldf3 */
    case 430:  /* adddf3 */
    case 429:  /* smaxsf3 */
    case 428:  /* sminsf3 */
    case 427:  /* mulsf3 */
    case 426:  /* addsf3 */
    case 425:  /* smaxhf3 */
    case 424:  /* sminhf3 */
    case 423:  /* mulhf3 */
    case 422:  /* addhf3 */
    case 420:  /* smaxv64df3 */
    case 418:  /* sminv64df3 */
    case 416:  /* mulv64df3 */
    case 414:  /* addv64df3 */
    case 412:  /* smaxv64sf3 */
    case 410:  /* sminv64sf3 */
    case 408:  /* mulv64sf3 */
    case 406:  /* addv64sf3 */
    case 404:  /* smaxv64hf3 */
    case 402:  /* sminv64hf3 */
    case 400:  /* mulv64hf3 */
    case 398:  /* addv64hf3 */
    case 397:  /* subdf3 */
    case 395:  /* subv64df3 */
    case 393:  /* umaxv64si3 */
    case 391:  /* uminv64si3 */
    case 389:  /* smaxv64si3 */
    case 387:  /* sminv64si3 */
    case 385:  /* vashrv64si3 */
    case 383:  /* vlshrv64si3 */
    case 381:  /* vashlv64si3 */
    case 371:  /* xorv64di3 */
    case 370:  /* iorv64di3 */
    case 369:  /* andv64di3 */
    case 367:  /* xorv64si3 */
    case 365:  /* iorv64si3 */
    case 363:  /* andv64si3 */
    case 361:  /* xorv64hi3 */
    case 359:  /* iorv64hi3 */
    case 357:  /* andv64hi3 */
    case 355:  /* xorv64qi3 */
    case 353:  /* iorv64qi3 */
    case 351:  /* andv64qi3 */
    case 325:  /* mulv64si3 */
    case 323:  /* mulv64hi3 */
    case 321:  /* mulv64qi3 */
    case 307:  /* subdi3_ds_scalar */
    case 306:  /* subsf3_ds_scalar */
    case 305:  /* subsi3_ds_scalar */
    case 303:  /* subv64di3_ds */
    case 301:  /* subv64sf3_ds */
    case 299:  /* subv64si3_ds */
    case 298:  /* adddi3_ds_scalar */
    case 297:  /* addsf3_ds_scalar */
    case 296:  /* addsi3_ds_scalar */
    case 294:  /* addv64di3_ds */
    case 292:  /* addv64sf3_ds */
    case 290:  /* addv64si3_ds */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 338:  /* mulv64di3_zext_dup2_exec */
    case 289:  /* addv64di3_sext_dup2_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 337:  /* mulv64di3_zext_dup2 */
    case 288:  /* addv64di3_sext_dup2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 287:  /* addv64di3_vcc_zext_dup2_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[3] = 5;
      break;

    case 286:  /* addv64di3_vcc_zext_dup2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 285:  /* addv64di3_vcc_zext_dup_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[3] = 5;
      break;

    case 284:  /* addv64di3_vcc_zext_dup */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 283:  /* addv64di3_zext_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      break;

    case 282:  /* addv64di3_zext */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 277:  /* subcv64si3_exec */
    case 267:  /* addcv64si3_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0), 0), 2);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0), 0), 2);
      recog_data.dup_num[4] = 3;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0), 1);
      recog_data.dup_num[5] = 1;
      recog_data.dup_loc[6] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 1);
      recog_data.dup_num[6] = 1;
      break;

    case 276:  /* subcv64si3 */
    case 266:  /* addcv64si3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0), 2);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 0), 2);
      recog_data.dup_num[4] = 3;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 1);
      recog_data.dup_num[5] = 1;
      recog_data.dup_loc[6] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[6] = 1;
      break;

    case 265:  /* addv64si3_vcc_dup_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[2] = 2;
      break;

    case 264:  /* addv64si3_vcc_dup */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[2] = 2;
      break;

    case 275:  /* subv64si3_vcc_exec */
    case 263:  /* addv64si3_vcc_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 261:  /* addv64si3_dup_exec */
    case 259:  /* addv64hi3_dup_exec */
    case 257:  /* addv64qi3_dup_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      break;

    case 260:  /* addv64si3_dup */
    case 258:  /* addv64hi3_dup */
    case 256:  /* addv64qi3_dup */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 281:  /* subv64di3_exec */
    case 279:  /* addv64di3_exec */
    case 273:  /* subv64si3_exec */
    case 271:  /* subv64hi3_exec */
    case 269:  /* subv64qi3_exec */
    case 255:  /* addv64si3_exec */
    case 253:  /* addv64hi3_exec */
    case 251:  /* addv64qi3_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      break;

    case 249:  /* dpp_movev64df */
    case 248:  /* dpp_movev64di */
    case 247:  /* dpp_movev64sf */
    case 246:  /* dpp_movev64si */
    case 245:  /* dpp_movev64hf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 244:  /* ds_bpermutev64df */
    case 243:  /* ds_bpermutev64di */
    case 242:  /* ds_bpermutev64sf */
    case 241:  /* ds_bpermutev64hf */
    case 240:  /* ds_bpermutev64si */
    case 239:  /* ds_bpermutev64hi */
    case 238:  /* ds_bpermutev64qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 237:  /* scatterv64df_insn_2offsets_exec */
    case 235:  /* scatterv64di_insn_2offsets_exec */
    case 233:  /* scatterv64sf_insn_2offsets_exec */
    case 231:  /* scatterv64si_insn_2offsets_exec */
    case 229:  /* scatterv64hf_insn_2offsets_exec */
    case 227:  /* scatterv64hi_insn_2offsets_exec */
    case 225:  /* scatterv64qi_insn_2offsets_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (pat, 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (pat, 1), 0, 4));
      break;

    case 236:  /* scatterv64df_insn_2offsets */
    case 234:  /* scatterv64di_insn_2offsets */
    case 232:  /* scatterv64sf_insn_2offsets */
    case 230:  /* scatterv64si_insn_2offsets */
    case 228:  /* scatterv64hf_insn_2offsets */
    case 226:  /* scatterv64hi_insn_2offsets */
    case 224:  /* scatterv64qi_insn_2offsets */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (pat, 1), 0, 3));
      break;

    case 223:  /* scatterv64df_insn_1offset_ds_exec */
    case 221:  /* scatterv64di_insn_1offset_ds_exec */
    case 219:  /* scatterv64sf_insn_1offset_ds_exec */
    case 217:  /* scatterv64si_insn_1offset_ds_exec */
    case 215:  /* scatterv64hf_insn_1offset_ds_exec */
    case 213:  /* scatterv64hi_insn_1offset_ds_exec */
    case 211:  /* scatterv64qi_insn_1offset_ds_exec */
    case 209:  /* scatterv64df_insn_1offset_exec */
    case 207:  /* scatterv64di_insn_1offset_exec */
    case 205:  /* scatterv64sf_insn_1offset_exec */
    case 203:  /* scatterv64si_insn_1offset_exec */
    case 201:  /* scatterv64hf_insn_1offset_exec */
    case 199:  /* scatterv64hi_insn_1offset_exec */
    case 197:  /* scatterv64qi_insn_1offset_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 3));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (pat, 1), 0, 4));
      break;

    case 222:  /* scatterv64df_insn_1offset_ds */
    case 220:  /* scatterv64di_insn_1offset_ds */
    case 218:  /* scatterv64sf_insn_1offset_ds */
    case 216:  /* scatterv64si_insn_1offset_ds */
    case 214:  /* scatterv64hf_insn_1offset_ds */
    case 212:  /* scatterv64hi_insn_1offset_ds */
    case 210:  /* scatterv64qi_insn_1offset_ds */
    case 208:  /* scatterv64df_insn_1offset */
    case 206:  /* scatterv64di_insn_1offset */
    case 204:  /* scatterv64sf_insn_1offset */
    case 202:  /* scatterv64si_insn_1offset */
    case 200:  /* scatterv64hf_insn_1offset */
    case 198:  /* scatterv64hi_insn_1offset */
    case 196:  /* scatterv64qi_insn_1offset */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 3));
      break;

    case 195:  /* gatherv64df_insn_2offsets_exec */
    case 193:  /* gatherv64di_insn_2offsets_exec */
    case 191:  /* gatherv64sf_insn_2offsets_exec */
    case 189:  /* gatherv64si_insn_2offsets_exec */
    case 187:  /* gatherv64hf_insn_2offsets_exec */
    case 185:  /* gatherv64hi_insn_2offsets_exec */
    case 183:  /* gatherv64qi_insn_2offsets_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 2));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 1), 1));
      ro[7] = *(ro_loc[7] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 194:  /* gatherv64df_insn_2offsets */
    case 192:  /* gatherv64di_insn_2offsets */
    case 190:  /* gatherv64sf_insn_2offsets */
    case 188:  /* gatherv64si_insn_2offsets */
    case 186:  /* gatherv64hf_insn_2offsets */
    case 184:  /* gatherv64hi_insn_2offsets */
    case 182:  /* gatherv64qi_insn_2offsets */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 181:  /* gatherv64df_insn_1offset_ds_exec */
    case 179:  /* gatherv64di_insn_1offset_ds_exec */
    case 177:  /* gatherv64sf_insn_1offset_ds_exec */
    case 175:  /* gatherv64si_insn_1offset_ds_exec */
    case 173:  /* gatherv64hf_insn_1offset_ds_exec */
    case 171:  /* gatherv64hi_insn_1offset_ds_exec */
    case 169:  /* gatherv64qi_insn_1offset_ds_exec */
    case 167:  /* gatherv64df_insn_1offset_exec */
    case 165:  /* gatherv64di_insn_1offset_exec */
    case 163:  /* gatherv64sf_insn_1offset_exec */
    case 161:  /* gatherv64si_insn_1offset_exec */
    case 159:  /* gatherv64hf_insn_1offset_exec */
    case 157:  /* gatherv64hi_insn_1offset_exec */
    case 155:  /* gatherv64qi_insn_1offset_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 2));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 1), 1));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 180:  /* gatherv64df_insn_1offset_ds */
    case 178:  /* gatherv64di_insn_1offset_ds */
    case 176:  /* gatherv64sf_insn_1offset_ds */
    case 174:  /* gatherv64si_insn_1offset_ds */
    case 172:  /* gatherv64hf_insn_1offset_ds */
    case 170:  /* gatherv64hi_insn_1offset_ds */
    case 168:  /* gatherv64qi_insn_1offset_ds */
    case 166:  /* gatherv64df_insn_1offset */
    case 164:  /* gatherv64di_insn_1offset */
    case 162:  /* gatherv64sf_insn_1offset */
    case 160:  /* gatherv64si_insn_1offset */
    case 158:  /* gatherv64hf_insn_1offset */
    case 156:  /* gatherv64hi_insn_1offset */
    case 154:  /* gatherv64qi_insn_1offset */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 153:  /* vec_extractv64dfdf */
    case 152:  /* vec_extractv64didi */
    case 151:  /* vec_extractv64sfsf */
    case 150:  /* vec_extractv64hfhf */
    case 149:  /* vec_extractv64sisi */
    case 148:  /* vec_extractv64hihi */
    case 147:  /* vec_extractv64qiqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 964:  /* zero_extendv64siv64di2_exec */
    case 963:  /* extendv64siv64di2_exec */
    case 962:  /* zero_extendv64hiv64di2_exec */
    case 961:  /* extendv64hiv64di2_exec */
    case 960:  /* zero_extendv64qiv64di2_exec */
    case 959:  /* extendv64qiv64di2_exec */
    case 952:  /* truncv64div64si2_exec */
    case 951:  /* truncv64div64hi2_exec */
    case 950:  /* truncv64div64qi2_exec */
    case 946:  /* extendv64siv64si2_exec */
    case 944:  /* extendv64hiv64si2_exec */
    case 942:  /* extendv64qiv64si2_exec */
    case 940:  /* extendv64siv64hi2_exec */
    case 938:  /* extendv64hiv64hi2_exec */
    case 936:  /* extendv64qiv64hi2_exec */
    case 934:  /* extendv64siv64qi2_exec */
    case 932:  /* extendv64hiv64qi2_exec */
    case 930:  /* extendv64qiv64qi2_exec */
    case 928:  /* zero_extendv64siv64si2_exec */
    case 926:  /* truncv64siv64si2_exec */
    case 924:  /* zero_extendv64hiv64si2_exec */
    case 922:  /* truncv64hiv64si2_exec */
    case 920:  /* zero_extendv64qiv64si2_exec */
    case 918:  /* truncv64qiv64si2_exec */
    case 916:  /* zero_extendv64siv64hi2_exec */
    case 914:  /* truncv64siv64hi2_exec */
    case 912:  /* zero_extendv64hiv64hi2_exec */
    case 910:  /* truncv64hiv64hi2_exec */
    case 908:  /* zero_extendv64qiv64hi2_exec */
    case 906:  /* truncv64qiv64hi2_exec */
    case 904:  /* zero_extendv64siv64qi2_exec */
    case 902:  /* truncv64siv64qi2_exec */
    case 900:  /* zero_extendv64hiv64qi2_exec */
    case 898:  /* truncv64hiv64qi2_exec */
    case 896:  /* zero_extendv64qiv64qi2_exec */
    case 894:  /* truncv64qiv64qi2_exec */
    case 892:  /* truncv64dfv64si2_exec */
    case 890:  /* extendv64dfv64si2_exec */
    case 888:  /* floatunsv64dfv64si2_exec */
    case 886:  /* floatv64dfv64si2_exec */
    case 884:  /* fixuns_truncv64dfv64si2_exec */
    case 882:  /* fix_truncv64dfv64si2_exec */
    case 880:  /* truncv64dfv64hi2_exec */
    case 878:  /* extendv64dfv64hi2_exec */
    case 876:  /* floatunsv64dfv64hi2_exec */
    case 874:  /* floatv64dfv64hi2_exec */
    case 872:  /* fixuns_truncv64dfv64hi2_exec */
    case 870:  /* fix_truncv64dfv64hi2_exec */
    case 868:  /* truncv64sfv64si2_exec */
    case 866:  /* extendv64sfv64si2_exec */
    case 864:  /* floatunsv64sfv64si2_exec */
    case 862:  /* floatv64sfv64si2_exec */
    case 860:  /* fixuns_truncv64sfv64si2_exec */
    case 858:  /* fix_truncv64sfv64si2_exec */
    case 856:  /* truncv64sfv64hi2_exec */
    case 854:  /* extendv64sfv64hi2_exec */
    case 852:  /* floatunsv64sfv64hi2_exec */
    case 850:  /* floatv64sfv64hi2_exec */
    case 848:  /* fixuns_truncv64sfv64hi2_exec */
    case 846:  /* fix_truncv64sfv64hi2_exec */
    case 844:  /* truncv64hfv64si2_exec */
    case 842:  /* extendv64hfv64si2_exec */
    case 840:  /* floatunsv64hfv64si2_exec */
    case 838:  /* floatv64hfv64si2_exec */
    case 836:  /* fixuns_truncv64hfv64si2_exec */
    case 834:  /* fix_truncv64hfv64si2_exec */
    case 832:  /* truncv64hfv64hi2_exec */
    case 830:  /* extendv64hfv64hi2_exec */
    case 828:  /* floatunsv64hfv64hi2_exec */
    case 826:  /* floatv64hfv64hi2_exec */
    case 824:  /* fixuns_truncv64hfv64hi2_exec */
    case 822:  /* fix_truncv64hfv64hi2_exec */
    case 820:  /* truncv64dfv64df2_exec */
    case 818:  /* extendv64dfv64df2_exec */
    case 816:  /* floatunsv64dfv64df2_exec */
    case 814:  /* floatv64dfv64df2_exec */
    case 812:  /* fixuns_truncv64dfv64df2_exec */
    case 810:  /* fix_truncv64dfv64df2_exec */
    case 808:  /* truncv64sfv64df2_exec */
    case 806:  /* extendv64sfv64df2_exec */
    case 804:  /* floatunsv64sfv64df2_exec */
    case 802:  /* floatv64sfv64df2_exec */
    case 800:  /* fixuns_truncv64sfv64df2_exec */
    case 798:  /* fix_truncv64sfv64df2_exec */
    case 796:  /* truncv64hfv64df2_exec */
    case 794:  /* extendv64hfv64df2_exec */
    case 792:  /* floatunsv64hfv64df2_exec */
    case 790:  /* floatv64hfv64df2_exec */
    case 788:  /* fixuns_truncv64hfv64df2_exec */
    case 786:  /* fix_truncv64hfv64df2_exec */
    case 784:  /* truncv64siv64df2_exec */
    case 782:  /* extendv64siv64df2_exec */
    case 780:  /* floatunsv64siv64df2_exec */
    case 778:  /* floatv64siv64df2_exec */
    case 776:  /* fixuns_truncv64siv64df2_exec */
    case 774:  /* fix_truncv64siv64df2_exec */
    case 772:  /* truncv64hiv64df2_exec */
    case 770:  /* extendv64hiv64df2_exec */
    case 768:  /* floatunsv64hiv64df2_exec */
    case 766:  /* floatv64hiv64df2_exec */
    case 764:  /* fixuns_truncv64hiv64df2_exec */
    case 762:  /* fix_truncv64hiv64df2_exec */
    case 760:  /* truncv64dfv64sf2_exec */
    case 758:  /* extendv64dfv64sf2_exec */
    case 756:  /* floatunsv64dfv64sf2_exec */
    case 754:  /* floatv64dfv64sf2_exec */
    case 752:  /* fixuns_truncv64dfv64sf2_exec */
    case 750:  /* fix_truncv64dfv64sf2_exec */
    case 748:  /* truncv64sfv64sf2_exec */
    case 746:  /* extendv64sfv64sf2_exec */
    case 744:  /* floatunsv64sfv64sf2_exec */
    case 742:  /* floatv64sfv64sf2_exec */
    case 740:  /* fixuns_truncv64sfv64sf2_exec */
    case 738:  /* fix_truncv64sfv64sf2_exec */
    case 736:  /* truncv64hfv64sf2_exec */
    case 734:  /* extendv64hfv64sf2_exec */
    case 732:  /* floatunsv64hfv64sf2_exec */
    case 730:  /* floatv64hfv64sf2_exec */
    case 728:  /* fixuns_truncv64hfv64sf2_exec */
    case 726:  /* fix_truncv64hfv64sf2_exec */
    case 724:  /* truncv64siv64sf2_exec */
    case 722:  /* extendv64siv64sf2_exec */
    case 720:  /* floatunsv64siv64sf2_exec */
    case 718:  /* floatv64siv64sf2_exec */
    case 716:  /* fixuns_truncv64siv64sf2_exec */
    case 714:  /* fix_truncv64siv64sf2_exec */
    case 712:  /* truncv64hiv64sf2_exec */
    case 710:  /* extendv64hiv64sf2_exec */
    case 708:  /* floatunsv64hiv64sf2_exec */
    case 706:  /* floatv64hiv64sf2_exec */
    case 704:  /* fixuns_truncv64hiv64sf2_exec */
    case 702:  /* fix_truncv64hiv64sf2_exec */
    case 700:  /* truncv64dfv64hf2_exec */
    case 698:  /* extendv64dfv64hf2_exec */
    case 696:  /* floatunsv64dfv64hf2_exec */
    case 694:  /* floatv64dfv64hf2_exec */
    case 692:  /* fixuns_truncv64dfv64hf2_exec */
    case 690:  /* fix_truncv64dfv64hf2_exec */
    case 688:  /* truncv64sfv64hf2_exec */
    case 686:  /* extendv64sfv64hf2_exec */
    case 684:  /* floatunsv64sfv64hf2_exec */
    case 682:  /* floatv64sfv64hf2_exec */
    case 680:  /* fixuns_truncv64sfv64hf2_exec */
    case 678:  /* fix_truncv64sfv64hf2_exec */
    case 676:  /* truncv64hfv64hf2_exec */
    case 674:  /* extendv64hfv64hf2_exec */
    case 672:  /* floatunsv64hfv64hf2_exec */
    case 670:  /* floatv64hfv64hf2_exec */
    case 668:  /* fixuns_truncv64hfv64hf2_exec */
    case 666:  /* fix_truncv64hfv64hf2_exec */
    case 664:  /* truncv64siv64hf2_exec */
    case 662:  /* extendv64siv64hf2_exec */
    case 660:  /* floatunsv64siv64hf2_exec */
    case 658:  /* floatv64siv64hf2_exec */
    case 656:  /* fixuns_truncv64siv64hf2_exec */
    case 654:  /* fix_truncv64siv64hf2_exec */
    case 652:  /* truncv64hiv64hf2_exec */
    case 650:  /* extendv64hiv64hf2_exec */
    case 648:  /* floatunsv64hiv64hf2_exec */
    case 646:  /* floatv64hiv64hf2_exec */
    case 644:  /* fixuns_truncv64hiv64hf2_exec */
    case 642:  /* fix_truncv64hiv64hf2_exec */
    case 460:  /* sqrtv64df2_exec */
    case 458:  /* sqrtv64sf2_exec */
    case 456:  /* sqrtv64hf2_exec */
    case 454:  /* negv64df2_exec */
    case 452:  /* negv64sf2_exec */
    case 450:  /* negv64hf2_exec */
    case 448:  /* absv64df2_exec */
    case 446:  /* absv64sf2_exec */
    case 444:  /* absv64hf2_exec */
    case 350:  /* popcountv64si2_exec */
    case 348:  /* one_cmplv64si2_exec */
    case 346:  /* popcountv64hi2_exec */
    case 344:  /* one_cmplv64hi2_exec */
    case 342:  /* popcountv64qi2_exec */
    case 340:  /* one_cmplv64qi2_exec */
    case 146:  /* vec_duplicatev64df_exec */
    case 144:  /* vec_duplicatev64di_exec */
    case 142:  /* vec_duplicatev64sf_exec */
    case 140:  /* vec_duplicatev64hf_exec */
    case 138:  /* vec_duplicatev64si_exec */
    case 136:  /* vec_duplicatev64hi_exec */
    case 134:  /* vec_duplicatev64qi_exec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 132:  /* *vec_setv64df_1 */
    case 131:  /* *vec_setv64di_1 */
    case 130:  /* *vec_setv64sf_1 */
    case 129:  /* *vec_setv64hf_1 */
    case 128:  /* *vec_setv64si_1 */
    case 127:  /* *vec_setv64hi_1 */
    case 126:  /* *vec_setv64qi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 125:  /* *vec_setv64df */
    case 124:  /* *vec_setv64di */
    case 123:  /* *vec_setv64sf */
    case 122:  /* *vec_setv64hf */
    case 121:  /* *vec_setv64si */
    case 120:  /* *vec_setv64hi */
    case 119:  /* *vec_setv64qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 111:  /* movv64df_exec */
    case 110:  /* movv64di_exec */
    case 107:  /* movv64sf_exec */
    case 106:  /* movv64hf_exec */
    case 105:  /* movv64si_exec */
    case 104:  /* movv64hi_exec */
    case 103:  /* movv64qi_exec */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 89:  /* atomic_exchangedi */
    case 88:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 118:  /* movv64df_sgprbase */
    case 117:  /* movv64di_sgprbase */
    case 116:  /* movv64sf_sgprbase */
    case 115:  /* movv64hf_sgprbase */
    case 114:  /* movv64si_sgprbase */
    case 113:  /* movv64hi_sgprbase */
    case 112:  /* movv64qi_sgprbase */
    case 87:  /* atomic_storedi */
    case 86:  /* atomic_storesi */
    case 85:  /* atomic_loaddi */
    case 84:  /* atomic_loadsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 83:  /* sync_compare_and_swapdi_lds_insn */
    case 82:  /* sync_compare_and_swapsi_lds_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 81:  /* sync_compare_and_swapdi_insn */
    case 80:  /* sync_compare_and_swapsi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 90:  /* *gcn_wavefront_barrier */
    case 79:  /* *memory_barrier */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1044:  /* mov_from_lane63_v64df */
    case 1043:  /* mov_from_lane63_v64di */
    case 1042:  /* mov_from_lane63_v64sf */
    case 1041:  /* mov_from_lane63_v64hf */
    case 1040:  /* mov_from_lane63_v64si */
    case 1039:  /* mov_from_lane63_v64hi */
    case 1038:  /* mov_from_lane63_v64qi */
    case 490:  /* recipdf2 */
    case 489:  /* recipsf2 */
    case 488:  /* reciphf2 */
    case 486:  /* recipv64df2 */
    case 484:  /* recipv64sf2 */
    case 482:  /* recipv64hf2 */
    case 62:  /* gcn_flbitdi_int */
    case 61:  /* gcn_flbitsi_int */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 60:  /* ctzdi2 */
    case 59:  /* clzdi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 958:  /* zero_extendv64siv64di2 */
    case 957:  /* extendv64siv64di2 */
    case 956:  /* zero_extendv64hiv64di2 */
    case 955:  /* extendv64hiv64di2 */
    case 954:  /* zero_extendv64qiv64di2 */
    case 953:  /* extendv64qiv64di2 */
    case 949:  /* truncv64div64si2 */
    case 948:  /* truncv64div64hi2 */
    case 947:  /* truncv64div64qi2 */
    case 945:  /* extendv64siv64si2 */
    case 943:  /* extendv64hiv64si2 */
    case 941:  /* extendv64qiv64si2 */
    case 939:  /* extendv64siv64hi2 */
    case 937:  /* extendv64hiv64hi2 */
    case 935:  /* extendv64qiv64hi2 */
    case 933:  /* extendv64siv64qi2 */
    case 931:  /* extendv64hiv64qi2 */
    case 929:  /* extendv64qiv64qi2 */
    case 927:  /* zero_extendv64siv64si2 */
    case 925:  /* truncv64siv64si2 */
    case 923:  /* zero_extendv64hiv64si2 */
    case 921:  /* truncv64hiv64si2 */
    case 919:  /* zero_extendv64qiv64si2 */
    case 917:  /* truncv64qiv64si2 */
    case 915:  /* zero_extendv64siv64hi2 */
    case 913:  /* truncv64siv64hi2 */
    case 911:  /* zero_extendv64hiv64hi2 */
    case 909:  /* truncv64hiv64hi2 */
    case 907:  /* zero_extendv64qiv64hi2 */
    case 905:  /* truncv64qiv64hi2 */
    case 903:  /* zero_extendv64siv64qi2 */
    case 901:  /* truncv64siv64qi2 */
    case 899:  /* zero_extendv64hiv64qi2 */
    case 897:  /* truncv64hiv64qi2 */
    case 895:  /* zero_extendv64qiv64qi2 */
    case 893:  /* truncv64qiv64qi2 */
    case 891:  /* truncv64dfv64si2 */
    case 889:  /* extendv64dfv64si2 */
    case 887:  /* floatunsv64dfv64si2 */
    case 885:  /* floatv64dfv64si2 */
    case 883:  /* fixuns_truncv64dfv64si2 */
    case 881:  /* fix_truncv64dfv64si2 */
    case 879:  /* truncv64dfv64hi2 */
    case 877:  /* extendv64dfv64hi2 */
    case 875:  /* floatunsv64dfv64hi2 */
    case 873:  /* floatv64dfv64hi2 */
    case 871:  /* fixuns_truncv64dfv64hi2 */
    case 869:  /* fix_truncv64dfv64hi2 */
    case 867:  /* truncv64sfv64si2 */
    case 865:  /* extendv64sfv64si2 */
    case 863:  /* floatunsv64sfv64si2 */
    case 861:  /* floatv64sfv64si2 */
    case 859:  /* fixuns_truncv64sfv64si2 */
    case 857:  /* fix_truncv64sfv64si2 */
    case 855:  /* truncv64sfv64hi2 */
    case 853:  /* extendv64sfv64hi2 */
    case 851:  /* floatunsv64sfv64hi2 */
    case 849:  /* floatv64sfv64hi2 */
    case 847:  /* fixuns_truncv64sfv64hi2 */
    case 845:  /* fix_truncv64sfv64hi2 */
    case 843:  /* truncv64hfv64si2 */
    case 841:  /* extendv64hfv64si2 */
    case 839:  /* floatunsv64hfv64si2 */
    case 837:  /* floatv64hfv64si2 */
    case 835:  /* fixuns_truncv64hfv64si2 */
    case 833:  /* fix_truncv64hfv64si2 */
    case 831:  /* truncv64hfv64hi2 */
    case 829:  /* extendv64hfv64hi2 */
    case 827:  /* floatunsv64hfv64hi2 */
    case 825:  /* floatv64hfv64hi2 */
    case 823:  /* fixuns_truncv64hfv64hi2 */
    case 821:  /* fix_truncv64hfv64hi2 */
    case 819:  /* truncv64dfv64df2 */
    case 817:  /* extendv64dfv64df2 */
    case 815:  /* floatunsv64dfv64df2 */
    case 813:  /* floatv64dfv64df2 */
    case 811:  /* fixuns_truncv64dfv64df2 */
    case 809:  /* fix_truncv64dfv64df2 */
    case 807:  /* truncv64sfv64df2 */
    case 805:  /* extendv64sfv64df2 */
    case 803:  /* floatunsv64sfv64df2 */
    case 801:  /* floatv64sfv64df2 */
    case 799:  /* fixuns_truncv64sfv64df2 */
    case 797:  /* fix_truncv64sfv64df2 */
    case 795:  /* truncv64hfv64df2 */
    case 793:  /* extendv64hfv64df2 */
    case 791:  /* floatunsv64hfv64df2 */
    case 789:  /* floatv64hfv64df2 */
    case 787:  /* fixuns_truncv64hfv64df2 */
    case 785:  /* fix_truncv64hfv64df2 */
    case 783:  /* truncv64siv64df2 */
    case 781:  /* extendv64siv64df2 */
    case 779:  /* floatunsv64siv64df2 */
    case 777:  /* floatv64siv64df2 */
    case 775:  /* fixuns_truncv64siv64df2 */
    case 773:  /* fix_truncv64siv64df2 */
    case 771:  /* truncv64hiv64df2 */
    case 769:  /* extendv64hiv64df2 */
    case 767:  /* floatunsv64hiv64df2 */
    case 765:  /* floatv64hiv64df2 */
    case 763:  /* fixuns_truncv64hiv64df2 */
    case 761:  /* fix_truncv64hiv64df2 */
    case 759:  /* truncv64dfv64sf2 */
    case 757:  /* extendv64dfv64sf2 */
    case 755:  /* floatunsv64dfv64sf2 */
    case 753:  /* floatv64dfv64sf2 */
    case 751:  /* fixuns_truncv64dfv64sf2 */
    case 749:  /* fix_truncv64dfv64sf2 */
    case 747:  /* truncv64sfv64sf2 */
    case 745:  /* extendv64sfv64sf2 */
    case 743:  /* floatunsv64sfv64sf2 */
    case 741:  /* floatv64sfv64sf2 */
    case 739:  /* fixuns_truncv64sfv64sf2 */
    case 737:  /* fix_truncv64sfv64sf2 */
    case 735:  /* truncv64hfv64sf2 */
    case 733:  /* extendv64hfv64sf2 */
    case 731:  /* floatunsv64hfv64sf2 */
    case 729:  /* floatv64hfv64sf2 */
    case 727:  /* fixuns_truncv64hfv64sf2 */
    case 725:  /* fix_truncv64hfv64sf2 */
    case 723:  /* truncv64siv64sf2 */
    case 721:  /* extendv64siv64sf2 */
    case 719:  /* floatunsv64siv64sf2 */
    case 717:  /* floatv64siv64sf2 */
    case 715:  /* fixuns_truncv64siv64sf2 */
    case 713:  /* fix_truncv64siv64sf2 */
    case 711:  /* truncv64hiv64sf2 */
    case 709:  /* extendv64hiv64sf2 */
    case 707:  /* floatunsv64hiv64sf2 */
    case 705:  /* floatv64hiv64sf2 */
    case 703:  /* fixuns_truncv64hiv64sf2 */
    case 701:  /* fix_truncv64hiv64sf2 */
    case 699:  /* truncv64dfv64hf2 */
    case 697:  /* extendv64dfv64hf2 */
    case 695:  /* floatunsv64dfv64hf2 */
    case 693:  /* floatv64dfv64hf2 */
    case 691:  /* fixuns_truncv64dfv64hf2 */
    case 689:  /* fix_truncv64dfv64hf2 */
    case 687:  /* truncv64sfv64hf2 */
    case 685:  /* extendv64sfv64hf2 */
    case 683:  /* floatunsv64sfv64hf2 */
    case 681:  /* floatv64sfv64hf2 */
    case 679:  /* fixuns_truncv64sfv64hf2 */
    case 677:  /* fix_truncv64sfv64hf2 */
    case 675:  /* truncv64hfv64hf2 */
    case 673:  /* extendv64hfv64hf2 */
    case 671:  /* floatunsv64hfv64hf2 */
    case 669:  /* floatv64hfv64hf2 */
    case 667:  /* fixuns_truncv64hfv64hf2 */
    case 665:  /* fix_truncv64hfv64hf2 */
    case 663:  /* truncv64siv64hf2 */
    case 661:  /* extendv64siv64hf2 */
    case 659:  /* floatunsv64siv64hf2 */
    case 657:  /* floatv64siv64hf2 */
    case 655:  /* fixuns_truncv64siv64hf2 */
    case 653:  /* fix_truncv64siv64hf2 */
    case 651:  /* truncv64hiv64hf2 */
    case 649:  /* extendv64hiv64hf2 */
    case 647:  /* floatunsv64hiv64hf2 */
    case 645:  /* floatv64hiv64hf2 */
    case 643:  /* fixuns_truncv64hiv64hf2 */
    case 641:  /* fix_truncv64hiv64hf2 */
    case 640:  /* truncdfdf2 */
    case 639:  /* extenddfdf2 */
    case 638:  /* floatunsdfdf2 */
    case 637:  /* floatdfdf2 */
    case 636:  /* fixuns_truncdfdf2 */
    case 635:  /* fix_truncdfdf2 */
    case 634:  /* truncsfdf2 */
    case 633:  /* extendsfdf2 */
    case 632:  /* floatunssfdf2 */
    case 631:  /* floatsfdf2 */
    case 630:  /* fixuns_truncsfdf2 */
    case 629:  /* fix_truncsfdf2 */
    case 628:  /* trunchfdf2 */
    case 627:  /* extendhfdf2 */
    case 626:  /* floatunshfdf2 */
    case 625:  /* floathfdf2 */
    case 624:  /* fixuns_trunchfdf2 */
    case 623:  /* fix_trunchfdf2 */
    case 622:  /* truncsidf2 */
    case 621:  /* extendsidf2 */
    case 620:  /* floatunssidf2 */
    case 619:  /* floatsidf2 */
    case 618:  /* fixuns_truncsidf2 */
    case 617:  /* fix_truncsidf2 */
    case 616:  /* trunchidf2 */
    case 615:  /* extendhidf2 */
    case 614:  /* floatunshidf2 */
    case 613:  /* floathidf2 */
    case 612:  /* fixuns_trunchidf2 */
    case 611:  /* fix_trunchidf2 */
    case 610:  /* truncdfsf2 */
    case 609:  /* extenddfsf2 */
    case 608:  /* floatunsdfsf2 */
    case 607:  /* floatdfsf2 */
    case 606:  /* fixuns_truncdfsf2 */
    case 605:  /* fix_truncdfsf2 */
    case 604:  /* truncsfsf2 */
    case 603:  /* extendsfsf2 */
    case 602:  /* floatunssfsf2 */
    case 601:  /* floatsfsf2 */
    case 600:  /* fixuns_truncsfsf2 */
    case 599:  /* fix_truncsfsf2 */
    case 598:  /* trunchfsf2 */
    case 597:  /* extendhfsf2 */
    case 596:  /* floatunshfsf2 */
    case 595:  /* floathfsf2 */
    case 594:  /* fixuns_trunchfsf2 */
    case 593:  /* fix_trunchfsf2 */
    case 592:  /* truncsisf2 */
    case 591:  /* extendsisf2 */
    case 590:  /* floatunssisf2 */
    case 589:  /* floatsisf2 */
    case 588:  /* fixuns_truncsisf2 */
    case 587:  /* fix_truncsisf2 */
    case 586:  /* trunchisf2 */
    case 585:  /* extendhisf2 */
    case 584:  /* floatunshisf2 */
    case 583:  /* floathisf2 */
    case 582:  /* fixuns_trunchisf2 */
    case 581:  /* fix_trunchisf2 */
    case 580:  /* truncdfhf2 */
    case 579:  /* extenddfhf2 */
    case 578:  /* floatunsdfhf2 */
    case 577:  /* floatdfhf2 */
    case 576:  /* fixuns_truncdfhf2 */
    case 575:  /* fix_truncdfhf2 */
    case 574:  /* truncsfhf2 */
    case 573:  /* extendsfhf2 */
    case 572:  /* floatunssfhf2 */
    case 571:  /* floatsfhf2 */
    case 570:  /* fixuns_truncsfhf2 */
    case 569:  /* fix_truncsfhf2 */
    case 568:  /* trunchfhf2 */
    case 567:  /* extendhfhf2 */
    case 566:  /* floatunshfhf2 */
    case 565:  /* floathfhf2 */
    case 564:  /* fixuns_trunchfhf2 */
    case 563:  /* fix_trunchfhf2 */
    case 562:  /* truncsihf2 */
    case 561:  /* extendsihf2 */
    case 560:  /* floatunssihf2 */
    case 559:  /* floatsihf2 */
    case 558:  /* fixuns_truncsihf2 */
    case 557:  /* fix_truncsihf2 */
    case 556:  /* trunchihf2 */
    case 555:  /* extendhihf2 */
    case 554:  /* floatunshihf2 */
    case 553:  /* floathihf2 */
    case 552:  /* fixuns_trunchihf2 */
    case 551:  /* fix_trunchihf2 */
    case 550:  /* truncdfsi2 */
    case 549:  /* extenddfsi2 */
    case 548:  /* floatunsdfsi2 */
    case 547:  /* floatdfsi2 */
    case 546:  /* fixuns_truncdfsi2 */
    case 545:  /* fix_truncdfsi2 */
    case 544:  /* truncsfsi2 */
    case 543:  /* extendsfsi2 */
    case 542:  /* floatunssfsi2 */
    case 541:  /* floatsfsi2 */
    case 540:  /* fixuns_truncsfsi2 */
    case 539:  /* fix_truncsfsi2 */
    case 538:  /* trunchfsi2 */
    case 537:  /* extendhfsi2 */
    case 536:  /* floatunshfsi2 */
    case 535:  /* floathfsi2 */
    case 534:  /* fixuns_trunchfsi2 */
    case 533:  /* fix_trunchfsi2 */
    case 532:  /* truncsisi2 */
    case 531:  /* extendsisi2 */
    case 530:  /* floatunssisi2 */
    case 529:  /* floatsisi2 */
    case 528:  /* fixuns_truncsisi2 */
    case 527:  /* fix_truncsisi2 */
    case 526:  /* trunchisi2 */
    case 525:  /* extendhisi2 */
    case 524:  /* floatunshisi2 */
    case 523:  /* floathisi2 */
    case 522:  /* fixuns_trunchisi2 */
    case 521:  /* fix_trunchisi2 */
    case 520:  /* truncdfhi2 */
    case 519:  /* extenddfhi2 */
    case 518:  /* floatunsdfhi2 */
    case 517:  /* floatdfhi2 */
    case 516:  /* fixuns_truncdfhi2 */
    case 515:  /* fix_truncdfhi2 */
    case 514:  /* truncsfhi2 */
    case 513:  /* extendsfhi2 */
    case 512:  /* floatunssfhi2 */
    case 511:  /* floatsfhi2 */
    case 510:  /* fixuns_truncsfhi2 */
    case 509:  /* fix_truncsfhi2 */
    case 508:  /* trunchfhi2 */
    case 507:  /* extendhfhi2 */
    case 506:  /* floatunshfhi2 */
    case 505:  /* floathfhi2 */
    case 504:  /* fixuns_trunchfhi2 */
    case 503:  /* fix_trunchfhi2 */
    case 502:  /* truncsihi2 */
    case 501:  /* extendsihi2 */
    case 500:  /* floatunssihi2 */
    case 499:  /* floatsihi2 */
    case 498:  /* fixuns_truncsihi2 */
    case 497:  /* fix_truncsihi2 */
    case 496:  /* trunchihi2 */
    case 495:  /* extendhihi2 */
    case 494:  /* floatunshihi2 */
    case 493:  /* floathihi2 */
    case 492:  /* fixuns_trunchihi2 */
    case 491:  /* fix_trunchihi2 */
    case 463:  /* sqrtdf2 */
    case 462:  /* sqrtsf2 */
    case 461:  /* sqrthf2 */
    case 459:  /* sqrtv64df2 */
    case 457:  /* sqrtv64sf2 */
    case 455:  /* sqrtv64hf2 */
    case 453:  /* negv64df2 */
    case 451:  /* negv64sf2 */
    case 449:  /* negv64hf2 */
    case 447:  /* absv64df2 */
    case 445:  /* absv64sf2 */
    case 443:  /* absv64hf2 */
    case 442:  /* absdf2 */
    case 441:  /* abssf2 */
    case 440:  /* abshf2 */
    case 349:  /* popcountv64si2 */
    case 347:  /* one_cmplv64si2 */
    case 345:  /* popcountv64hi2 */
    case 343:  /* one_cmplv64hi2 */
    case 341:  /* popcountv64qi2 */
    case 339:  /* one_cmplv64qi2 */
    case 145:  /* vec_duplicatev64df */
    case 143:  /* vec_duplicatev64di */
    case 141:  /* vec_duplicatev64sf */
    case 139:  /* vec_duplicatev64hf */
    case 137:  /* vec_duplicatev64si */
    case 135:  /* vec_duplicatev64hi */
    case 133:  /* vec_duplicatev64qi */
    case 58:  /* ctzsi2 */
    case 57:  /* clzsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 56:  /* popcountsi2 */
    case 55:  /* one_cmplsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 50:  /* muldi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 49:  /* umulsidi3_imm */
    case 48:  /* smulsidi3_imm */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 54:  /* umulqihi3_scalar */
    case 53:  /* mulqihi3_scalar */
    case 52:  /* umulhisi3 */
    case 51:  /* mulhisi3 */
    case 47:  /* umulsidi3_reg */
    case 46:  /* smulsidi3_reg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 45:  /* umulsi3_highpart_imm */
    case 44:  /* smulsi3_highpart_imm */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 319:  /* umulv64si3_highpart */
    case 317:  /* smulv64si3_highpart */
    case 43:  /* umulsi3_highpart_reg */
    case 42:  /* smulsi3_highpart_reg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 333:  /* mulv64di3 */
    case 78:  /* ashrdi3 */
    case 77:  /* lshrdi3 */
    case 76:  /* ashldi3 */
    case 75:  /* xordi3 */
    case 74:  /* iordi3 */
    case 73:  /* anddi3 */
    case 72:  /* ashrsi3 */
    case 71:  /* lshrsi3 */
    case 70:  /* ashlsi3 */
    case 69:  /* umaxsi3 */
    case 68:  /* uminsi3 */
    case 67:  /* smaxsi3 */
    case 66:  /* sminsi3 */
    case 65:  /* xorsi3 */
    case 64:  /* iorsi3 */
    case 63:  /* andsi3 */
    case 41:  /* mulsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 40:  /* subcsi3_scalar_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 1;
      break;

    case 39:  /* subcsi3_scalar */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 1);
      recog_data.dup_num[3] = 1;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[4] = 1;
      break;

    case 38:  /* subsi3_scalar_carry_cst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 37:  /* subsi3_scalar_carry */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 280:  /* subv64di3 */
    case 278:  /* addv64di3 */
    case 272:  /* subv64si3 */
    case 270:  /* subv64hi3 */
    case 268:  /* subv64qi3 */
    case 254:  /* addv64si3 */
    case 252:  /* addv64hi3 */
    case 250:  /* addv64qi3 */
    case 36:  /* subdi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 34:  /* addptrdi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      break;

    case 33:  /* addcsi3_scalar_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[3] = 1;
      break;

    case 32:  /* addcsi3_scalar */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0), 0);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 0), 0);
      recog_data.dup_num[4] = 3;
      recog_data.dup_loc[5] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 1);
      recog_data.dup_num[5] = 1;
      recog_data.dup_loc[6] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[6] = 1;
      break;

    case 31:  /* addsi3_scalar_carry_cst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 274:  /* subv64si3_vcc */
    case 262:  /* addv64si3_vcc */
    case 30:  /* addsi3_scalar_carry */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 35:  /* subsi3 */
    case 29:  /* adddi3 */
    case 28:  /* addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 27:  /* cstoredf4 */
    case 26:  /* cstoresf4 */
    case 25:  /* cstoredi4_vector */
    case 24:  /* cstoredi4_vec_and_scalar */
    case 23:  /* cstoresi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 22:  /* clear_icache */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 21:  /* gcn_call_value_indirect */
    case 20:  /* gcn_call_value */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 18:  /* movdi_symbol_save_scc */
    case 17:  /* movdi_symbol */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 19:  /* gcn_indirect_call */
    case 16:  /* gcn_simple_call */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 14:  /* cjump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 13:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 12:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 11:  /* prologue_use */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 109:  /* *movv64df */
    case 108:  /* *movv64di */
    case 102:  /* *movv64sf */
    case 101:  /* *movv64hf */
    case 100:  /* *movv64si */
    case 99:  /* *movv64hi */
    case 98:  /* *movv64qi */
    case 97:  /* movv64df_unspec */
    case 96:  /* movv64di_unspec */
    case 95:  /* movv64sf_unspec */
    case 94:  /* movv64si_unspec */
    case 93:  /* movv64hf_unspec */
    case 92:  /* movv64hi_unspec */
    case 91:  /* movv64qi_unspec */
    case 10:  /* *movti_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
    case 7:  /* *movhi_insn */
    case 6:  /* *movqi_insn */
    case 5:  /* *movsf_insn */
    case 4:  /* *movsi_insn */
    case 3:  /* *movbi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 15:  /* gcn_return */
    case 2:  /* trap */
    case 1:  /* nop */
      break;

    }
}
