/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010505, CODE_FOR_extendhihi2 },
  { 0x010506, CODE_FOR_extendhisi2 },
  { 0x01051b, CODE_FOR_extendhihf2 },
  { 0x01051c, CODE_FOR_extendhisf2 },
  { 0x01051d, CODE_FOR_extendhidf2 },
  { 0x010605, CODE_FOR_extendsihi2 },
  { 0x010606, CODE_FOR_extendsisi2 },
  { 0x01061b, CODE_FOR_extendsihf2 },
  { 0x01061c, CODE_FOR_extendsisf2 },
  { 0x01061d, CODE_FOR_extendsidf2 },
  { 0x011b05, CODE_FOR_extendhfhi2 },
  { 0x011b06, CODE_FOR_extendhfsi2 },
  { 0x011b1b, CODE_FOR_extendhfhf2 },
  { 0x011b1c, CODE_FOR_extendhfsf2 },
  { 0x011b1d, CODE_FOR_extendhfdf2 },
  { 0x011c05, CODE_FOR_extendsfhi2 },
  { 0x011c06, CODE_FOR_extendsfsi2 },
  { 0x011c1b, CODE_FOR_extendsfhf2 },
  { 0x011c1c, CODE_FOR_extendsfsf2 },
  { 0x011c1d, CODE_FOR_extendsfdf2 },
  { 0x011d05, CODE_FOR_extenddfhi2 },
  { 0x011d06, CODE_FOR_extenddfsi2 },
  { 0x011d1b, CODE_FOR_extenddfhf2 },
  { 0x011d1c, CODE_FOR_extenddfsf2 },
  { 0x011d1d, CODE_FOR_extenddfdf2 },
  { 0x012929, CODE_FOR_extendv64qiv64qi2 },
  { 0x01292a, CODE_FOR_extendv64qiv64hi2 },
  { 0x01292b, CODE_FOR_extendv64qiv64si2 },
  { 0x01292c, CODE_FOR_extendv64qiv64di2 },
  { 0x012a29, CODE_FOR_extendv64hiv64qi2 },
  { 0x012a2a, CODE_FOR_extendv64hiv64hi2 },
  { 0x012a2b, CODE_FOR_extendv64hiv64si2 },
  { 0x012a2c, CODE_FOR_extendv64hiv64di2 },
  { 0x012a2e, CODE_FOR_extendv64hiv64hf2 },
  { 0x012a2f, CODE_FOR_extendv64hiv64sf2 },
  { 0x012a30, CODE_FOR_extendv64hiv64df2 },
  { 0x012b29, CODE_FOR_extendv64siv64qi2 },
  { 0x012b2a, CODE_FOR_extendv64siv64hi2 },
  { 0x012b2b, CODE_FOR_extendv64siv64si2 },
  { 0x012b2c, CODE_FOR_extendv64siv64di2 },
  { 0x012b2e, CODE_FOR_extendv64siv64hf2 },
  { 0x012b2f, CODE_FOR_extendv64siv64sf2 },
  { 0x012b30, CODE_FOR_extendv64siv64df2 },
  { 0x012e2a, CODE_FOR_extendv64hfv64hi2 },
  { 0x012e2b, CODE_FOR_extendv64hfv64si2 },
  { 0x012e2e, CODE_FOR_extendv64hfv64hf2 },
  { 0x012e2f, CODE_FOR_extendv64hfv64sf2 },
  { 0x012e30, CODE_FOR_extendv64hfv64df2 },
  { 0x012f2a, CODE_FOR_extendv64sfv64hi2 },
  { 0x012f2b, CODE_FOR_extendv64sfv64si2 },
  { 0x012f2e, CODE_FOR_extendv64sfv64hf2 },
  { 0x012f2f, CODE_FOR_extendv64sfv64sf2 },
  { 0x012f30, CODE_FOR_extendv64sfv64df2 },
  { 0x01302a, CODE_FOR_extendv64dfv64hi2 },
  { 0x01302b, CODE_FOR_extendv64dfv64si2 },
  { 0x01302e, CODE_FOR_extendv64dfv64hf2 },
  { 0x01302f, CODE_FOR_extendv64dfv64sf2 },
  { 0x013030, CODE_FOR_extendv64dfv64df2 },
  { 0x020505, CODE_FOR_trunchihi2 },
  { 0x020506, CODE_FOR_trunchisi2 },
  { 0x02051b, CODE_FOR_trunchihf2 },
  { 0x02051c, CODE_FOR_trunchisf2 },
  { 0x02051d, CODE_FOR_trunchidf2 },
  { 0x020605, CODE_FOR_truncsihi2 },
  { 0x020606, CODE_FOR_truncsisi2 },
  { 0x02061b, CODE_FOR_truncsihf2 },
  { 0x02061c, CODE_FOR_truncsisf2 },
  { 0x02061d, CODE_FOR_truncsidf2 },
  { 0x021b05, CODE_FOR_trunchfhi2 },
  { 0x021b06, CODE_FOR_trunchfsi2 },
  { 0x021b1b, CODE_FOR_trunchfhf2 },
  { 0x021b1c, CODE_FOR_trunchfsf2 },
  { 0x021b1d, CODE_FOR_trunchfdf2 },
  { 0x021c05, CODE_FOR_truncsfhi2 },
  { 0x021c06, CODE_FOR_truncsfsi2 },
  { 0x021c1b, CODE_FOR_truncsfhf2 },
  { 0x021c1c, CODE_FOR_truncsfsf2 },
  { 0x021c1d, CODE_FOR_truncsfdf2 },
  { 0x021d05, CODE_FOR_truncdfhi2 },
  { 0x021d06, CODE_FOR_truncdfsi2 },
  { 0x021d1b, CODE_FOR_truncdfhf2 },
  { 0x021d1c, CODE_FOR_truncdfsf2 },
  { 0x021d1d, CODE_FOR_truncdfdf2 },
  { 0x022929, CODE_FOR_truncv64qiv64qi2 },
  { 0x02292a, CODE_FOR_truncv64qiv64hi2 },
  { 0x02292b, CODE_FOR_truncv64qiv64si2 },
  { 0x022a29, CODE_FOR_truncv64hiv64qi2 },
  { 0x022a2a, CODE_FOR_truncv64hiv64hi2 },
  { 0x022a2b, CODE_FOR_truncv64hiv64si2 },
  { 0x022a2e, CODE_FOR_truncv64hiv64hf2 },
  { 0x022a2f, CODE_FOR_truncv64hiv64sf2 },
  { 0x022a30, CODE_FOR_truncv64hiv64df2 },
  { 0x022b29, CODE_FOR_truncv64siv64qi2 },
  { 0x022b2a, CODE_FOR_truncv64siv64hi2 },
  { 0x022b2b, CODE_FOR_truncv64siv64si2 },
  { 0x022b2e, CODE_FOR_truncv64siv64hf2 },
  { 0x022b2f, CODE_FOR_truncv64siv64sf2 },
  { 0x022b30, CODE_FOR_truncv64siv64df2 },
  { 0x022c29, CODE_FOR_truncv64div64qi2 },
  { 0x022c2a, CODE_FOR_truncv64div64hi2 },
  { 0x022c2b, CODE_FOR_truncv64div64si2 },
  { 0x022e2a, CODE_FOR_truncv64hfv64hi2 },
  { 0x022e2b, CODE_FOR_truncv64hfv64si2 },
  { 0x022e2e, CODE_FOR_truncv64hfv64hf2 },
  { 0x022e2f, CODE_FOR_truncv64hfv64sf2 },
  { 0x022e30, CODE_FOR_truncv64hfv64df2 },
  { 0x022f2a, CODE_FOR_truncv64sfv64hi2 },
  { 0x022f2b, CODE_FOR_truncv64sfv64si2 },
  { 0x022f2e, CODE_FOR_truncv64sfv64hf2 },
  { 0x022f2f, CODE_FOR_truncv64sfv64sf2 },
  { 0x022f30, CODE_FOR_truncv64sfv64df2 },
  { 0x02302a, CODE_FOR_truncv64dfv64hi2 },
  { 0x02302b, CODE_FOR_truncv64dfv64si2 },
  { 0x02302e, CODE_FOR_truncv64dfv64hf2 },
  { 0x02302f, CODE_FOR_truncv64dfv64sf2 },
  { 0x023030, CODE_FOR_truncv64dfv64df2 },
  { 0x032929, CODE_FOR_zero_extendv64qiv64qi2 },
  { 0x03292a, CODE_FOR_zero_extendv64qiv64hi2 },
  { 0x03292b, CODE_FOR_zero_extendv64qiv64si2 },
  { 0x03292c, CODE_FOR_zero_extendv64qiv64di2 },
  { 0x032a29, CODE_FOR_zero_extendv64hiv64qi2 },
  { 0x032a2a, CODE_FOR_zero_extendv64hiv64hi2 },
  { 0x032a2b, CODE_FOR_zero_extendv64hiv64si2 },
  { 0x032a2c, CODE_FOR_zero_extendv64hiv64di2 },
  { 0x032b29, CODE_FOR_zero_extendv64siv64qi2 },
  { 0x032b2a, CODE_FOR_zero_extendv64siv64hi2 },
  { 0x032b2b, CODE_FOR_zero_extendv64siv64si2 },
  { 0x032b2c, CODE_FOR_zero_extendv64siv64di2 },
  { 0x06051b, CODE_FOR_floathihf2 },
  { 0x06051c, CODE_FOR_floathisf2 },
  { 0x06051d, CODE_FOR_floathidf2 },
  { 0x06061b, CODE_FOR_floatsihf2 },
  { 0x06061c, CODE_FOR_floatsisf2 },
  { 0x06061d, CODE_FOR_floatsidf2 },
  { 0x062a2e, CODE_FOR_floatv64hiv64hf2 },
  { 0x062a2f, CODE_FOR_floatv64hiv64sf2 },
  { 0x062a30, CODE_FOR_floatv64hiv64df2 },
  { 0x062b2e, CODE_FOR_floatv64siv64hf2 },
  { 0x062b2f, CODE_FOR_floatv64siv64sf2 },
  { 0x062b30, CODE_FOR_floatv64siv64df2 },
  { 0x07051b, CODE_FOR_floatunshihf2 },
  { 0x07051c, CODE_FOR_floatunshisf2 },
  { 0x07051d, CODE_FOR_floatunshidf2 },
  { 0x07061b, CODE_FOR_floatunssihf2 },
  { 0x07061c, CODE_FOR_floatunssisf2 },
  { 0x07061d, CODE_FOR_floatunssidf2 },
  { 0x072a2e, CODE_FOR_floatunsv64hiv64hf2 },
  { 0x072a2f, CODE_FOR_floatunsv64hiv64sf2 },
  { 0x072a30, CODE_FOR_floatunsv64hiv64df2 },
  { 0x072b2e, CODE_FOR_floatunsv64siv64hf2 },
  { 0x072b2f, CODE_FOR_floatunsv64siv64sf2 },
  { 0x072b30, CODE_FOR_floatunsv64siv64df2 },
  { 0x101b05, CODE_FOR_fix_trunchfhi2 },
  { 0x101b06, CODE_FOR_fix_trunchfsi2 },
  { 0x101c05, CODE_FOR_fix_truncsfhi2 },
  { 0x101c06, CODE_FOR_fix_truncsfsi2 },
  { 0x101d05, CODE_FOR_fix_truncdfhi2 },
  { 0x101d06, CODE_FOR_fix_truncdfsi2 },
  { 0x102e2a, CODE_FOR_fix_truncv64hfv64hi2 },
  { 0x102e2b, CODE_FOR_fix_truncv64hfv64si2 },
  { 0x102f2a, CODE_FOR_fix_truncv64sfv64hi2 },
  { 0x102f2b, CODE_FOR_fix_truncv64sfv64si2 },
  { 0x10302a, CODE_FOR_fix_truncv64dfv64hi2 },
  { 0x10302b, CODE_FOR_fix_truncv64dfv64si2 },
  { 0x111b05, CODE_FOR_fixuns_trunchfhi2 },
  { 0x111b06, CODE_FOR_fixuns_trunchfsi2 },
  { 0x111c05, CODE_FOR_fixuns_truncsfhi2 },
  { 0x111c06, CODE_FOR_fixuns_truncsfsi2 },
  { 0x111d05, CODE_FOR_fixuns_truncdfhi2 },
  { 0x111d06, CODE_FOR_fixuns_truncdfsi2 },
  { 0x112e2a, CODE_FOR_fixuns_truncv64hfv64hi2 },
  { 0x112e2b, CODE_FOR_fixuns_truncv64hfv64si2 },
  { 0x112f2a, CODE_FOR_fixuns_truncv64sfv64hi2 },
  { 0x112f2b, CODE_FOR_fixuns_truncv64sfv64si2 },
  { 0x11302a, CODE_FOR_fixuns_truncv64dfv64hi2 },
  { 0x11302b, CODE_FOR_fixuns_truncv64dfv64si2 },
  { 0x120506, CODE_FOR_mulhisi3 },
  { 0x130506, CODE_FOR_umulhisi3 },
  { 0x130607, CODE_FOR_umulsidi3 },
  { 0x212929, CODE_FOR_vcondv64qiv64qi },
  { 0x21292a, CODE_FOR_vcondv64hiv64qi },
  { 0x21292b, CODE_FOR_vcondv64siv64qi },
  { 0x21292c, CODE_FOR_vcondv64div64qi },
  { 0x21292e, CODE_FOR_vcondv64hfv64qi },
  { 0x21292f, CODE_FOR_vcondv64sfv64qi },
  { 0x212930, CODE_FOR_vcondv64dfv64qi },
  { 0x212a29, CODE_FOR_vcondv64qiv64hi },
  { 0x212a2a, CODE_FOR_vcondv64hiv64hi },
  { 0x212a2b, CODE_FOR_vcondv64siv64hi },
  { 0x212a2c, CODE_FOR_vcondv64div64hi },
  { 0x212a2e, CODE_FOR_vcondv64hfv64hi },
  { 0x212a2f, CODE_FOR_vcondv64sfv64hi },
  { 0x212a30, CODE_FOR_vcondv64dfv64hi },
  { 0x212b29, CODE_FOR_vcondv64qiv64si },
  { 0x212b2a, CODE_FOR_vcondv64hiv64si },
  { 0x212b2b, CODE_FOR_vcondv64siv64si },
  { 0x212b2c, CODE_FOR_vcondv64div64si },
  { 0x212b2e, CODE_FOR_vcondv64hfv64si },
  { 0x212b2f, CODE_FOR_vcondv64sfv64si },
  { 0x212b30, CODE_FOR_vcondv64dfv64si },
  { 0x212c29, CODE_FOR_vcondv64qiv64di },
  { 0x212c2a, CODE_FOR_vcondv64hiv64di },
  { 0x212c2b, CODE_FOR_vcondv64siv64di },
  { 0x212c2c, CODE_FOR_vcondv64div64di },
  { 0x212c2e, CODE_FOR_vcondv64hfv64di },
  { 0x212c2f, CODE_FOR_vcondv64sfv64di },
  { 0x212c30, CODE_FOR_vcondv64dfv64di },
  { 0x212e29, CODE_FOR_vcondv64qiv64hf },
  { 0x212e2a, CODE_FOR_vcondv64hiv64hf },
  { 0x212e2b, CODE_FOR_vcondv64siv64hf },
  { 0x212e2c, CODE_FOR_vcondv64div64hf },
  { 0x212e2e, CODE_FOR_vcondv64hfv64hf },
  { 0x212e2f, CODE_FOR_vcondv64sfv64hf },
  { 0x212e30, CODE_FOR_vcondv64dfv64hf },
  { 0x212f29, CODE_FOR_vcondv64qiv64sf },
  { 0x212f2a, CODE_FOR_vcondv64hiv64sf },
  { 0x212f2b, CODE_FOR_vcondv64siv64sf },
  { 0x212f2c, CODE_FOR_vcondv64div64sf },
  { 0x212f2e, CODE_FOR_vcondv64hfv64sf },
  { 0x212f2f, CODE_FOR_vcondv64sfv64sf },
  { 0x212f30, CODE_FOR_vcondv64dfv64sf },
  { 0x213029, CODE_FOR_vcondv64qiv64df },
  { 0x21302a, CODE_FOR_vcondv64hiv64df },
  { 0x21302b, CODE_FOR_vcondv64siv64df },
  { 0x21302c, CODE_FOR_vcondv64div64df },
  { 0x21302e, CODE_FOR_vcondv64hfv64df },
  { 0x21302f, CODE_FOR_vcondv64sfv64df },
  { 0x213030, CODE_FOR_vcondv64dfv64df },
  { 0x222929, CODE_FOR_vconduv64qiv64qi },
  { 0x22292a, CODE_FOR_vconduv64hiv64qi },
  { 0x22292b, CODE_FOR_vconduv64siv64qi },
  { 0x22292c, CODE_FOR_vconduv64div64qi },
  { 0x22292e, CODE_FOR_vconduv64hfv64qi },
  { 0x22292f, CODE_FOR_vconduv64sfv64qi },
  { 0x222930, CODE_FOR_vconduv64dfv64qi },
  { 0x222a29, CODE_FOR_vconduv64qiv64hi },
  { 0x222a2a, CODE_FOR_vconduv64hiv64hi },
  { 0x222a2b, CODE_FOR_vconduv64siv64hi },
  { 0x222a2c, CODE_FOR_vconduv64div64hi },
  { 0x222a2e, CODE_FOR_vconduv64hfv64hi },
  { 0x222a2f, CODE_FOR_vconduv64sfv64hi },
  { 0x222a30, CODE_FOR_vconduv64dfv64hi },
  { 0x222b29, CODE_FOR_vconduv64qiv64si },
  { 0x222b2a, CODE_FOR_vconduv64hiv64si },
  { 0x222b2b, CODE_FOR_vconduv64siv64si },
  { 0x222b2c, CODE_FOR_vconduv64div64si },
  { 0x222b2e, CODE_FOR_vconduv64hfv64si },
  { 0x222b2f, CODE_FOR_vconduv64sfv64si },
  { 0x222b30, CODE_FOR_vconduv64dfv64si },
  { 0x222c29, CODE_FOR_vconduv64qiv64di },
  { 0x222c2a, CODE_FOR_vconduv64hiv64di },
  { 0x222c2b, CODE_FOR_vconduv64siv64di },
  { 0x222c2c, CODE_FOR_vconduv64div64di },
  { 0x222c2e, CODE_FOR_vconduv64hfv64di },
  { 0x222c2f, CODE_FOR_vconduv64sfv64di },
  { 0x222c30, CODE_FOR_vconduv64dfv64di },
  { 0x240729, CODE_FOR_vcond_mask_v64qidi },
  { 0x24072a, CODE_FOR_vcond_mask_v64hidi },
  { 0x24072b, CODE_FOR_vcond_mask_v64sidi },
  { 0x24072c, CODE_FOR_vcond_mask_v64didi },
  { 0x24072e, CODE_FOR_vcond_mask_v64hfdi },
  { 0x24072f, CODE_FOR_vcond_mask_v64sfdi },
  { 0x240730, CODE_FOR_vcond_mask_v64dfdi },
  { 0x250729, CODE_FOR_vec_cmpv64qidi },
  { 0x25072a, CODE_FOR_vec_cmpv64hidi },
  { 0x25072b, CODE_FOR_vec_cmpv64sidi },
  { 0x25072c, CODE_FOR_vec_cmpv64didi },
  { 0x25072e, CODE_FOR_vec_cmpv64hfdi },
  { 0x25072f, CODE_FOR_vec_cmpv64sfdi },
  { 0x250730, CODE_FOR_vec_cmpv64dfdi },
  { 0x260729, CODE_FOR_vec_cmpuv64qidi },
  { 0x26072a, CODE_FOR_vec_cmpuv64hidi },
  { 0x26072b, CODE_FOR_vec_cmpuv64sidi },
  { 0x26072c, CODE_FOR_vec_cmpuv64didi },
  { 0x280729, CODE_FOR_maskloadv64qidi },
  { 0x28072a, CODE_FOR_maskloadv64hidi },
  { 0x28072b, CODE_FOR_maskloadv64sidi },
  { 0x28072c, CODE_FOR_maskloadv64didi },
  { 0x28072e, CODE_FOR_maskloadv64hfdi },
  { 0x28072f, CODE_FOR_maskloadv64sfdi },
  { 0x280730, CODE_FOR_maskloadv64dfdi },
  { 0x290729, CODE_FOR_maskstorev64qidi },
  { 0x29072a, CODE_FOR_maskstorev64hidi },
  { 0x29072b, CODE_FOR_maskstorev64sidi },
  { 0x29072c, CODE_FOR_maskstorev64didi },
  { 0x29072e, CODE_FOR_maskstorev64hfdi },
  { 0x29072f, CODE_FOR_maskstorev64sfdi },
  { 0x290730, CODE_FOR_maskstorev64dfdi },
  { 0x2a2b29, CODE_FOR_gather_loadv64qiv64si },
  { 0x2a2b2a, CODE_FOR_gather_loadv64hiv64si },
  { 0x2a2b2b, CODE_FOR_gather_loadv64siv64si },
  { 0x2a2b2c, CODE_FOR_gather_loadv64div64si },
  { 0x2a2b2e, CODE_FOR_gather_loadv64hfv64si },
  { 0x2a2b2f, CODE_FOR_gather_loadv64sfv64si },
  { 0x2a2b30, CODE_FOR_gather_loadv64dfv64si },
  { 0x2b2b29, CODE_FOR_mask_gather_loadv64qiv64si },
  { 0x2b2b2a, CODE_FOR_mask_gather_loadv64hiv64si },
  { 0x2b2b2b, CODE_FOR_mask_gather_loadv64siv64si },
  { 0x2b2b2c, CODE_FOR_mask_gather_loadv64div64si },
  { 0x2b2b2e, CODE_FOR_mask_gather_loadv64hfv64si },
  { 0x2b2b2f, CODE_FOR_mask_gather_loadv64sfv64si },
  { 0x2b2b30, CODE_FOR_mask_gather_loadv64dfv64si },
  { 0x2c2b29, CODE_FOR_scatter_storev64qiv64si },
  { 0x2c2b2a, CODE_FOR_scatter_storev64hiv64si },
  { 0x2c2b2b, CODE_FOR_scatter_storev64siv64si },
  { 0x2c2b2c, CODE_FOR_scatter_storev64div64si },
  { 0x2c2b2e, CODE_FOR_scatter_storev64hfv64si },
  { 0x2c2b2f, CODE_FOR_scatter_storev64sfv64si },
  { 0x2c2b30, CODE_FOR_scatter_storev64dfv64si },
  { 0x2d2b29, CODE_FOR_mask_scatter_storev64qiv64si },
  { 0x2d2b2a, CODE_FOR_mask_scatter_storev64hiv64si },
  { 0x2d2b2b, CODE_FOR_mask_scatter_storev64siv64si },
  { 0x2d2b2c, CODE_FOR_mask_scatter_storev64div64si },
  { 0x2d2b2e, CODE_FOR_mask_scatter_storev64hfv64si },
  { 0x2d2b2f, CODE_FOR_mask_scatter_storev64sfv64si },
  { 0x2d2b30, CODE_FOR_mask_scatter_storev64dfv64si },
  { 0x2e0429, CODE_FOR_vec_extractv64qiqi },
  { 0x2e052a, CODE_FOR_vec_extractv64hihi },
  { 0x2e062b, CODE_FOR_vec_extractv64sisi },
  { 0x2e072c, CODE_FOR_vec_extractv64didi },
  { 0x2e1b2e, CODE_FOR_vec_extractv64hfhf },
  { 0x2e1c2f, CODE_FOR_vec_extractv64sfsf },
  { 0x2e1d30, CODE_FOR_vec_extractv64dfdf },
  { 0x2f0429, CODE_FOR_vec_initv64qiqi },
  { 0x2f052a, CODE_FOR_vec_initv64hihi },
  { 0x2f062b, CODE_FOR_vec_initv64sisi },
  { 0x2f072c, CODE_FOR_vec_initv64didi },
  { 0x2f1b2e, CODE_FOR_vec_initv64hfhf },
  { 0x2f1c2f, CODE_FOR_vec_initv64sfsf },
  { 0x2f1d30, CODE_FOR_vec_initv64dfdf },
  { 0x300706, CODE_FOR_while_ultsidi },
  { 0x310006, CODE_FOR_addsi3 },
  { 0x310007, CODE_FOR_adddi3 },
  { 0x31001b, CODE_FOR_addhf3 },
  { 0x31001c, CODE_FOR_addsf3 },
  { 0x31001d, CODE_FOR_adddf3 },
  { 0x310029, CODE_FOR_addv64qi3 },
  { 0x31002a, CODE_FOR_addv64hi3 },
  { 0x31002b, CODE_FOR_addv64si3 },
  { 0x31002c, CODE_FOR_addv64di3 },
  { 0x31002e, CODE_FOR_addv64hf3 },
  { 0x31002f, CODE_FOR_addv64sf3 },
  { 0x310030, CODE_FOR_addv64df3 },
  { 0x350006, CODE_FOR_subsi3 },
  { 0x350007, CODE_FOR_subdi3 },
  { 0x35001b, CODE_FOR_subhf3 },
  { 0x35001c, CODE_FOR_subsf3 },
  { 0x35001d, CODE_FOR_subdf3 },
  { 0x350029, CODE_FOR_subv64qi3 },
  { 0x35002a, CODE_FOR_subv64hi3 },
  { 0x35002b, CODE_FOR_subv64si3 },
  { 0x35002c, CODE_FOR_subv64di3 },
  { 0x35002e, CODE_FOR_subv64hf3 },
  { 0x35002f, CODE_FOR_subv64sf3 },
  { 0x350030, CODE_FOR_subv64df3 },
  { 0x390006, CODE_FOR_mulsi3 },
  { 0x390007, CODE_FOR_muldi3 },
  { 0x39001b, CODE_FOR_mulhf3 },
  { 0x39001c, CODE_FOR_mulsf3 },
  { 0x39001d, CODE_FOR_muldf3 },
  { 0x390029, CODE_FOR_mulv64qi3 },
  { 0x39002a, CODE_FOR_mulv64hi3 },
  { 0x39002b, CODE_FOR_mulv64si3 },
  { 0x39002c, CODE_FOR_mulv64di3 },
  { 0x39002e, CODE_FOR_mulv64hf3 },
  { 0x39002f, CODE_FOR_mulv64sf3 },
  { 0x390030, CODE_FOR_mulv64df3 },
  { 0x3d001b, CODE_FOR_divhf3 },
  { 0x3d001c, CODE_FOR_divsf3 },
  { 0x3d001d, CODE_FOR_divdf3 },
  { 0x3d002e, CODE_FOR_divv64hf3 },
  { 0x3d002f, CODE_FOR_divv64sf3 },
  { 0x3d0030, CODE_FOR_divv64df3 },
  { 0x470006, CODE_FOR_andsi3 },
  { 0x470007, CODE_FOR_anddi3 },
  { 0x470029, CODE_FOR_andv64qi3 },
  { 0x47002a, CODE_FOR_andv64hi3 },
  { 0x47002b, CODE_FOR_andv64si3 },
  { 0x47002c, CODE_FOR_andv64di3 },
  { 0x480006, CODE_FOR_iorsi3 },
  { 0x480007, CODE_FOR_iordi3 },
  { 0x480029, CODE_FOR_iorv64qi3 },
  { 0x48002a, CODE_FOR_iorv64hi3 },
  { 0x48002b, CODE_FOR_iorv64si3 },
  { 0x48002c, CODE_FOR_iorv64di3 },
  { 0x490006, CODE_FOR_xorsi3 },
  { 0x490007, CODE_FOR_xordi3 },
  { 0x490029, CODE_FOR_xorv64qi3 },
  { 0x49002a, CODE_FOR_xorv64hi3 },
  { 0x49002b, CODE_FOR_xorv64si3 },
  { 0x49002c, CODE_FOR_xorv64di3 },
  { 0x4a0006, CODE_FOR_ashlsi3 },
  { 0x4a0007, CODE_FOR_ashldi3 },
  { 0x4a0008, CODE_FOR_ashlti3 },
  { 0x4a0029, CODE_FOR_ashlv64qi3 },
  { 0x4a002a, CODE_FOR_ashlv64hi3 },
  { 0x4a002b, CODE_FOR_ashlv64si3 },
  { 0x4d0006, CODE_FOR_ashrsi3 },
  { 0x4d0007, CODE_FOR_ashrdi3 },
  { 0x4d0008, CODE_FOR_ashrti3 },
  { 0x4d0029, CODE_FOR_ashrv64qi3 },
  { 0x4d002a, CODE_FOR_ashrv64hi3 },
  { 0x4d002b, CODE_FOR_ashrv64si3 },
  { 0x4e0006, CODE_FOR_lshrsi3 },
  { 0x4e0007, CODE_FOR_lshrdi3 },
  { 0x4e0008, CODE_FOR_lshrti3 },
  { 0x4e0029, CODE_FOR_lshrv64qi3 },
  { 0x4e002a, CODE_FOR_lshrv64hi3 },
  { 0x4e002b, CODE_FOR_lshrv64si3 },
  { 0x510029, CODE_FOR_vashlv64qi3 },
  { 0x51002a, CODE_FOR_vashlv64hi3 },
  { 0x51002b, CODE_FOR_vashlv64si3 },
  { 0x520029, CODE_FOR_vashrv64qi3 },
  { 0x52002a, CODE_FOR_vashrv64hi3 },
  { 0x52002b, CODE_FOR_vashrv64si3 },
  { 0x530029, CODE_FOR_vlshrv64qi3 },
  { 0x53002a, CODE_FOR_vlshrv64hi3 },
  { 0x53002b, CODE_FOR_vlshrv64si3 },
  { 0x560006, CODE_FOR_sminsi3 },
  { 0x56001b, CODE_FOR_sminhf3 },
  { 0x56001c, CODE_FOR_sminsf3 },
  { 0x56001d, CODE_FOR_smindf3 },
  { 0x560029, CODE_FOR_sminv64qi3 },
  { 0x56002a, CODE_FOR_sminv64hi3 },
  { 0x56002b, CODE_FOR_sminv64si3 },
  { 0x56002e, CODE_FOR_sminv64hf3 },
  { 0x56002f, CODE_FOR_sminv64sf3 },
  { 0x560030, CODE_FOR_sminv64df3 },
  { 0x570006, CODE_FOR_smaxsi3 },
  { 0x57001b, CODE_FOR_smaxhf3 },
  { 0x57001c, CODE_FOR_smaxsf3 },
  { 0x57001d, CODE_FOR_smaxdf3 },
  { 0x570029, CODE_FOR_smaxv64qi3 },
  { 0x57002a, CODE_FOR_smaxv64hi3 },
  { 0x57002b, CODE_FOR_smaxv64si3 },
  { 0x57002e, CODE_FOR_smaxv64hf3 },
  { 0x57002f, CODE_FOR_smaxv64sf3 },
  { 0x570030, CODE_FOR_smaxv64df3 },
  { 0x580006, CODE_FOR_uminsi3 },
  { 0x580029, CODE_FOR_uminv64qi3 },
  { 0x58002a, CODE_FOR_uminv64hi3 },
  { 0x58002b, CODE_FOR_uminv64si3 },
  { 0x590006, CODE_FOR_umaxsi3 },
  { 0x590029, CODE_FOR_umaxv64qi3 },
  { 0x59002a, CODE_FOR_umaxv64hi3 },
  { 0x59002b, CODE_FOR_umaxv64si3 },
  { 0x5a002e, CODE_FOR_negv64hf2 },
  { 0x5a002f, CODE_FOR_negv64sf2 },
  { 0x5a0030, CODE_FOR_negv64df2 },
  { 0x5e001b, CODE_FOR_abshf2 },
  { 0x5e001c, CODE_FOR_abssf2 },
  { 0x5e001d, CODE_FOR_absdf2 },
  { 0x5e002e, CODE_FOR_absv64hf2 },
  { 0x5e002f, CODE_FOR_absv64sf2 },
  { 0x5e0030, CODE_FOR_absv64df2 },
  { 0x600006, CODE_FOR_one_cmplsi2 },
  { 0x600029, CODE_FOR_one_cmplv64qi2 },
  { 0x60002a, CODE_FOR_one_cmplv64hi2 },
  { 0x60002b, CODE_FOR_one_cmplv64si2 },
  { 0x630006, CODE_FOR_clzsi2 },
  { 0x630007, CODE_FOR_clzdi2 },
  { 0x640006, CODE_FOR_ctzsi2 },
  { 0x640007, CODE_FOR_ctzdi2 },
  { 0x650006, CODE_FOR_clrsbsi2 },
  { 0x650007, CODE_FOR_clrsbdi2 },
  { 0x660006, CODE_FOR_popcountsi2 },
  { 0x660029, CODE_FOR_popcountv64qi2 },
  { 0x66002a, CODE_FOR_popcountv64hi2 },
  { 0x66002b, CODE_FOR_popcountv64si2 },
  { 0x72001b, CODE_FOR_sqrthf2 },
  { 0x72001c, CODE_FOR_sqrtsf2 },
  { 0x72001d, CODE_FOR_sqrtdf2 },
  { 0x72002e, CODE_FOR_sqrtv64hf2 },
  { 0x72002f, CODE_FOR_sqrtv64sf2 },
  { 0x720030, CODE_FOR_sqrtv64df2 },
  { 0x7f0006, CODE_FOR_sync_compare_and_swapsi },
  { 0x7f0007, CODE_FOR_sync_compare_and_swapdi },
  { 0x810003, CODE_FOR_movbi },
  { 0x810004, CODE_FOR_movqi },
  { 0x810005, CODE_FOR_movhi },
  { 0x810006, CODE_FOR_movsi },
  { 0x810007, CODE_FOR_movdi },
  { 0x810008, CODE_FOR_movti },
  { 0x81001c, CODE_FOR_movsf },
  { 0x81001d, CODE_FOR_movdf },
  { 0x810029, CODE_FOR_movv64qi },
  { 0x81002a, CODE_FOR_movv64hi },
  { 0x81002b, CODE_FOR_movv64si },
  { 0x81002c, CODE_FOR_movv64di },
  { 0x81002e, CODE_FOR_movv64hf },
  { 0x81002f, CODE_FOR_movv64sf },
  { 0x810030, CODE_FOR_movv64df },
  { 0x8c0029, CODE_FOR_reload_inv64qi },
  { 0x8c002a, CODE_FOR_reload_inv64hi },
  { 0x8c002b, CODE_FOR_reload_inv64si },
  { 0x8c002c, CODE_FOR_reload_inv64di },
  { 0x8c002e, CODE_FOR_reload_inv64hf },
  { 0x8c002f, CODE_FOR_reload_inv64sf },
  { 0x8c0030, CODE_FOR_reload_inv64df },
  { 0x8d0029, CODE_FOR_reload_outv64qi },
  { 0x8d002a, CODE_FOR_reload_outv64hi },
  { 0x8d002b, CODE_FOR_reload_outv64si },
  { 0x8d002c, CODE_FOR_reload_outv64di },
  { 0x8d002e, CODE_FOR_reload_outv64hf },
  { 0x8d002f, CODE_FOR_reload_outv64sf },
  { 0x8d0030, CODE_FOR_reload_outv64df },
  { 0x8e0006, CODE_FOR_cbranchsi4 },
  { 0x8e0007, CODE_FOR_cbranchdi4 },
  { 0x8e001c, CODE_FOR_cbranchsf4 },
  { 0x8e001d, CODE_FOR_cbranchdf4 },
  { 0x930029, CODE_FOR_cond_addv64qi },
  { 0x93002a, CODE_FOR_cond_addv64hi },
  { 0x93002b, CODE_FOR_cond_addv64si },
  { 0x93002c, CODE_FOR_cond_addv64di },
  { 0x93002e, CODE_FOR_cond_addv64hf },
  { 0x93002f, CODE_FOR_cond_addv64sf },
  { 0x930030, CODE_FOR_cond_addv64df },
  { 0x940029, CODE_FOR_cond_subv64qi },
  { 0x94002a, CODE_FOR_cond_subv64hi },
  { 0x94002b, CODE_FOR_cond_subv64si },
  { 0x94002c, CODE_FOR_cond_subv64di },
  { 0x94002e, CODE_FOR_cond_subv64hf },
  { 0x94002f, CODE_FOR_cond_subv64sf },
  { 0x940030, CODE_FOR_cond_subv64df },
  { 0x950029, CODE_FOR_cond_mulv64qi },
  { 0x95002a, CODE_FOR_cond_mulv64hi },
  { 0x95002b, CODE_FOR_cond_mulv64si },
  { 0x95002c, CODE_FOR_cond_mulv64di },
  { 0x95002e, CODE_FOR_cond_mulv64hf },
  { 0x95002f, CODE_FOR_cond_mulv64sf },
  { 0x950030, CODE_FOR_cond_mulv64df },
  { 0x9a0029, CODE_FOR_cond_andv64qi },
  { 0x9a002a, CODE_FOR_cond_andv64hi },
  { 0x9a002b, CODE_FOR_cond_andv64si },
  { 0x9a002c, CODE_FOR_cond_andv64di },
  { 0x9b0029, CODE_FOR_cond_iorv64qi },
  { 0x9b002a, CODE_FOR_cond_iorv64hi },
  { 0x9b002b, CODE_FOR_cond_iorv64si },
  { 0x9b002c, CODE_FOR_cond_iorv64di },
  { 0x9c0029, CODE_FOR_cond_xorv64qi },
  { 0x9c002a, CODE_FOR_cond_xorv64hi },
  { 0x9c002b, CODE_FOR_cond_xorv64si },
  { 0x9c002c, CODE_FOR_cond_xorv64di },
  { 0xac0006, CODE_FOR_cstoresi4 },
  { 0xac0007, CODE_FOR_cstoredi4 },
  { 0xac001c, CODE_FOR_cstoresf4 },
  { 0xac001d, CODE_FOR_cstoredf4 },
  { 0xb50007, CODE_FOR_addptrdi3 },
  { 0xb70006, CODE_FOR_smulsi3_highpart },
  { 0xb7002b, CODE_FOR_smulv64si3_highpart },
  { 0xb80006, CODE_FOR_umulsi3_highpart },
  { 0xb8002b, CODE_FOR_umulv64si3_highpart },
  { 0xc1001b, CODE_FOR_fmahf4 },
  { 0xc1001c, CODE_FOR_fmasf4 },
  { 0xc1001d, CODE_FOR_fmadf4 },
  { 0xc1002e, CODE_FOR_fmav64hf4 },
  { 0xc1002f, CODE_FOR_fmav64sf4 },
  { 0xc10030, CODE_FOR_fmav64df4 },
  { 0xff0029, CODE_FOR_reduc_smax_scal_v64qi },
  { 0xff002a, CODE_FOR_reduc_smax_scal_v64hi },
  { 0xff002b, CODE_FOR_reduc_smax_scal_v64si },
  { 0xff002c, CODE_FOR_reduc_smax_scal_v64di },
  { 0xff002e, CODE_FOR_reduc_smax_scal_v64hf },
  { 0xff002f, CODE_FOR_reduc_smax_scal_v64sf },
  { 0xff0030, CODE_FOR_reduc_smax_scal_v64df },
  { 0x1000029, CODE_FOR_reduc_smin_scal_v64qi },
  { 0x100002a, CODE_FOR_reduc_smin_scal_v64hi },
  { 0x100002b, CODE_FOR_reduc_smin_scal_v64si },
  { 0x100002c, CODE_FOR_reduc_smin_scal_v64di },
  { 0x100002e, CODE_FOR_reduc_smin_scal_v64hf },
  { 0x100002f, CODE_FOR_reduc_smin_scal_v64sf },
  { 0x1000030, CODE_FOR_reduc_smin_scal_v64df },
  { 0x1010029, CODE_FOR_reduc_plus_scal_v64qi },
  { 0x101002a, CODE_FOR_reduc_plus_scal_v64hi },
  { 0x101002b, CODE_FOR_reduc_plus_scal_v64si },
  { 0x101002c, CODE_FOR_reduc_plus_scal_v64di },
  { 0x101002e, CODE_FOR_reduc_plus_scal_v64hf },
  { 0x101002f, CODE_FOR_reduc_plus_scal_v64sf },
  { 0x1010030, CODE_FOR_reduc_plus_scal_v64df },
  { 0x1020029, CODE_FOR_reduc_umax_scal_v64qi },
  { 0x102002a, CODE_FOR_reduc_umax_scal_v64hi },
  { 0x102002b, CODE_FOR_reduc_umax_scal_v64si },
  { 0x102002c, CODE_FOR_reduc_umax_scal_v64di },
  { 0x102002e, CODE_FOR_reduc_umax_scal_v64hf },
  { 0x102002f, CODE_FOR_reduc_umax_scal_v64sf },
  { 0x1020030, CODE_FOR_reduc_umax_scal_v64df },
  { 0x1030029, CODE_FOR_reduc_umin_scal_v64qi },
  { 0x103002a, CODE_FOR_reduc_umin_scal_v64hi },
  { 0x103002b, CODE_FOR_reduc_umin_scal_v64si },
  { 0x103002c, CODE_FOR_reduc_umin_scal_v64di },
  { 0x103002e, CODE_FOR_reduc_umin_scal_v64hf },
  { 0x103002f, CODE_FOR_reduc_umin_scal_v64sf },
  { 0x1030030, CODE_FOR_reduc_umin_scal_v64df },
  { 0x1040029, CODE_FOR_reduc_and_scal_v64qi },
  { 0x104002a, CODE_FOR_reduc_and_scal_v64hi },
  { 0x104002b, CODE_FOR_reduc_and_scal_v64si },
  { 0x104002c, CODE_FOR_reduc_and_scal_v64di },
  { 0x104002e, CODE_FOR_reduc_and_scal_v64hf },
  { 0x104002f, CODE_FOR_reduc_and_scal_v64sf },
  { 0x1040030, CODE_FOR_reduc_and_scal_v64df },
  { 0x1050029, CODE_FOR_reduc_ior_scal_v64qi },
  { 0x105002a, CODE_FOR_reduc_ior_scal_v64hi },
  { 0x105002b, CODE_FOR_reduc_ior_scal_v64si },
  { 0x105002c, CODE_FOR_reduc_ior_scal_v64di },
  { 0x105002e, CODE_FOR_reduc_ior_scal_v64hf },
  { 0x105002f, CODE_FOR_reduc_ior_scal_v64sf },
  { 0x1050030, CODE_FOR_reduc_ior_scal_v64df },
  { 0x1060029, CODE_FOR_reduc_xor_scal_v64qi },
  { 0x106002a, CODE_FOR_reduc_xor_scal_v64hi },
  { 0x106002b, CODE_FOR_reduc_xor_scal_v64si },
  { 0x106002c, CODE_FOR_reduc_xor_scal_v64di },
  { 0x106002e, CODE_FOR_reduc_xor_scal_v64hf },
  { 0x106002f, CODE_FOR_reduc_xor_scal_v64sf },
  { 0x1060030, CODE_FOR_reduc_xor_scal_v64df },
  { 0x107002e, CODE_FOR_fold_left_plus_v64hf },
  { 0x107002f, CODE_FOR_fold_left_plus_v64sf },
  { 0x1070030, CODE_FOR_fold_left_plus_v64df },
  { 0x1090029, CODE_FOR_extract_last_v64qi },
  { 0x109002a, CODE_FOR_extract_last_v64hi },
  { 0x109002b, CODE_FOR_extract_last_v64si },
  { 0x109002c, CODE_FOR_extract_last_v64di },
  { 0x109002e, CODE_FOR_extract_last_v64hf },
  { 0x109002f, CODE_FOR_extract_last_v64sf },
  { 0x1090030, CODE_FOR_extract_last_v64df },
  { 0x10a0029, CODE_FOR_fold_extract_last_v64qi },
  { 0x10a002a, CODE_FOR_fold_extract_last_v64hi },
  { 0x10a002b, CODE_FOR_fold_extract_last_v64si },
  { 0x10a002c, CODE_FOR_fold_extract_last_v64di },
  { 0x10a002e, CODE_FOR_fold_extract_last_v64hf },
  { 0x10a002f, CODE_FOR_fold_extract_last_v64sf },
  { 0x10a0030, CODE_FOR_fold_extract_last_v64df },
  { 0x1250029, CODE_FOR_vec_setv64qi },
  { 0x125002a, CODE_FOR_vec_setv64hi },
  { 0x125002b, CODE_FOR_vec_setv64si },
  { 0x125002c, CODE_FOR_vec_setv64di },
  { 0x125002e, CODE_FOR_vec_setv64hf },
  { 0x125002f, CODE_FOR_vec_setv64sf },
  { 0x1250030, CODE_FOR_vec_setv64df },
  { 0x15c0006, CODE_FOR_atomic_exchangesi },
  { 0x15c0007, CODE_FOR_atomic_exchangedi },
  { 0x1630006, CODE_FOR_atomic_loadsi },
  { 0x1630007, CODE_FOR_atomic_loaddi },
  { 0x1680006, CODE_FOR_atomic_storesi },
  { 0x1680007, CODE_FOR_atomic_storedi },
  { 0x1760029, CODE_FOR_vec_duplicatev64qi },
  { 0x176002a, CODE_FOR_vec_duplicatev64hi },
  { 0x176002b, CODE_FOR_vec_duplicatev64si },
  { 0x176002c, CODE_FOR_vec_duplicatev64di },
  { 0x176002e, CODE_FOR_vec_duplicatev64hf },
  { 0x176002f, CODE_FOR_vec_duplicatev64sf },
  { 0x1760030, CODE_FOR_vec_duplicatev64df },
  { 0x177002b, CODE_FOR_vec_seriesv64si },
  { 0x177002c, CODE_FOR_vec_seriesv64di },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendhihi2;
  ena[1] = HAVE_extendhisi2;
  ena[2] = HAVE_extendhihf2;
  ena[3] = HAVE_extendhisf2;
  ena[4] = HAVE_extendhidf2;
  ena[5] = HAVE_extendsihi2;
  ena[6] = HAVE_extendsisi2;
  ena[7] = HAVE_extendsihf2;
  ena[8] = HAVE_extendsisf2;
  ena[9] = HAVE_extendsidf2;
  ena[10] = HAVE_extendhfhi2;
  ena[11] = HAVE_extendhfsi2;
  ena[12] = HAVE_extendhfhf2;
  ena[13] = HAVE_extendhfsf2;
  ena[14] = HAVE_extendhfdf2;
  ena[15] = HAVE_extendsfhi2;
  ena[16] = HAVE_extendsfsi2;
  ena[17] = HAVE_extendsfhf2;
  ena[18] = HAVE_extendsfsf2;
  ena[19] = HAVE_extendsfdf2;
  ena[20] = HAVE_extenddfhi2;
  ena[21] = HAVE_extenddfsi2;
  ena[22] = HAVE_extenddfhf2;
  ena[23] = HAVE_extenddfsf2;
  ena[24] = HAVE_extenddfdf2;
  ena[25] = HAVE_extendv64qiv64qi2;
  ena[26] = HAVE_extendv64qiv64hi2;
  ena[27] = HAVE_extendv64qiv64si2;
  ena[28] = HAVE_extendv64qiv64di2;
  ena[29] = HAVE_extendv64hiv64qi2;
  ena[30] = HAVE_extendv64hiv64hi2;
  ena[31] = HAVE_extendv64hiv64si2;
  ena[32] = HAVE_extendv64hiv64di2;
  ena[33] = HAVE_extendv64hiv64hf2;
  ena[34] = HAVE_extendv64hiv64sf2;
  ena[35] = HAVE_extendv64hiv64df2;
  ena[36] = HAVE_extendv64siv64qi2;
  ena[37] = HAVE_extendv64siv64hi2;
  ena[38] = HAVE_extendv64siv64si2;
  ena[39] = HAVE_extendv64siv64di2;
  ena[40] = HAVE_extendv64siv64hf2;
  ena[41] = HAVE_extendv64siv64sf2;
  ena[42] = HAVE_extendv64siv64df2;
  ena[43] = HAVE_extendv64hfv64hi2;
  ena[44] = HAVE_extendv64hfv64si2;
  ena[45] = HAVE_extendv64hfv64hf2;
  ena[46] = HAVE_extendv64hfv64sf2;
  ena[47] = HAVE_extendv64hfv64df2;
  ena[48] = HAVE_extendv64sfv64hi2;
  ena[49] = HAVE_extendv64sfv64si2;
  ena[50] = HAVE_extendv64sfv64hf2;
  ena[51] = HAVE_extendv64sfv64sf2;
  ena[52] = HAVE_extendv64sfv64df2;
  ena[53] = HAVE_extendv64dfv64hi2;
  ena[54] = HAVE_extendv64dfv64si2;
  ena[55] = HAVE_extendv64dfv64hf2;
  ena[56] = HAVE_extendv64dfv64sf2;
  ena[57] = HAVE_extendv64dfv64df2;
  ena[58] = HAVE_trunchihi2;
  ena[59] = HAVE_trunchisi2;
  ena[60] = HAVE_trunchihf2;
  ena[61] = HAVE_trunchisf2;
  ena[62] = HAVE_trunchidf2;
  ena[63] = HAVE_truncsihi2;
  ena[64] = HAVE_truncsisi2;
  ena[65] = HAVE_truncsihf2;
  ena[66] = HAVE_truncsisf2;
  ena[67] = HAVE_truncsidf2;
  ena[68] = HAVE_trunchfhi2;
  ena[69] = HAVE_trunchfsi2;
  ena[70] = HAVE_trunchfhf2;
  ena[71] = HAVE_trunchfsf2;
  ena[72] = HAVE_trunchfdf2;
  ena[73] = HAVE_truncsfhi2;
  ena[74] = HAVE_truncsfsi2;
  ena[75] = HAVE_truncsfhf2;
  ena[76] = HAVE_truncsfsf2;
  ena[77] = HAVE_truncsfdf2;
  ena[78] = HAVE_truncdfhi2;
  ena[79] = HAVE_truncdfsi2;
  ena[80] = HAVE_truncdfhf2;
  ena[81] = HAVE_truncdfsf2;
  ena[82] = HAVE_truncdfdf2;
  ena[83] = HAVE_truncv64qiv64qi2;
  ena[84] = HAVE_truncv64qiv64hi2;
  ena[85] = HAVE_truncv64qiv64si2;
  ena[86] = HAVE_truncv64hiv64qi2;
  ena[87] = HAVE_truncv64hiv64hi2;
  ena[88] = HAVE_truncv64hiv64si2;
  ena[89] = HAVE_truncv64hiv64hf2;
  ena[90] = HAVE_truncv64hiv64sf2;
  ena[91] = HAVE_truncv64hiv64df2;
  ena[92] = HAVE_truncv64siv64qi2;
  ena[93] = HAVE_truncv64siv64hi2;
  ena[94] = HAVE_truncv64siv64si2;
  ena[95] = HAVE_truncv64siv64hf2;
  ena[96] = HAVE_truncv64siv64sf2;
  ena[97] = HAVE_truncv64siv64df2;
  ena[98] = HAVE_truncv64div64qi2;
  ena[99] = HAVE_truncv64div64hi2;
  ena[100] = HAVE_truncv64div64si2;
  ena[101] = HAVE_truncv64hfv64hi2;
  ena[102] = HAVE_truncv64hfv64si2;
  ena[103] = HAVE_truncv64hfv64hf2;
  ena[104] = HAVE_truncv64hfv64sf2;
  ena[105] = HAVE_truncv64hfv64df2;
  ena[106] = HAVE_truncv64sfv64hi2;
  ena[107] = HAVE_truncv64sfv64si2;
  ena[108] = HAVE_truncv64sfv64hf2;
  ena[109] = HAVE_truncv64sfv64sf2;
  ena[110] = HAVE_truncv64sfv64df2;
  ena[111] = HAVE_truncv64dfv64hi2;
  ena[112] = HAVE_truncv64dfv64si2;
  ena[113] = HAVE_truncv64dfv64hf2;
  ena[114] = HAVE_truncv64dfv64sf2;
  ena[115] = HAVE_truncv64dfv64df2;
  ena[116] = HAVE_zero_extendv64qiv64qi2;
  ena[117] = HAVE_zero_extendv64qiv64hi2;
  ena[118] = HAVE_zero_extendv64qiv64si2;
  ena[119] = HAVE_zero_extendv64qiv64di2;
  ena[120] = HAVE_zero_extendv64hiv64qi2;
  ena[121] = HAVE_zero_extendv64hiv64hi2;
  ena[122] = HAVE_zero_extendv64hiv64si2;
  ena[123] = HAVE_zero_extendv64hiv64di2;
  ena[124] = HAVE_zero_extendv64siv64qi2;
  ena[125] = HAVE_zero_extendv64siv64hi2;
  ena[126] = HAVE_zero_extendv64siv64si2;
  ena[127] = HAVE_zero_extendv64siv64di2;
  ena[128] = HAVE_floathihf2;
  ena[129] = HAVE_floathisf2;
  ena[130] = HAVE_floathidf2;
  ena[131] = HAVE_floatsihf2;
  ena[132] = HAVE_floatsisf2;
  ena[133] = HAVE_floatsidf2;
  ena[134] = HAVE_floatv64hiv64hf2;
  ena[135] = HAVE_floatv64hiv64sf2;
  ena[136] = HAVE_floatv64hiv64df2;
  ena[137] = HAVE_floatv64siv64hf2;
  ena[138] = HAVE_floatv64siv64sf2;
  ena[139] = HAVE_floatv64siv64df2;
  ena[140] = HAVE_floatunshihf2;
  ena[141] = HAVE_floatunshisf2;
  ena[142] = HAVE_floatunshidf2;
  ena[143] = HAVE_floatunssihf2;
  ena[144] = HAVE_floatunssisf2;
  ena[145] = HAVE_floatunssidf2;
  ena[146] = HAVE_floatunsv64hiv64hf2;
  ena[147] = HAVE_floatunsv64hiv64sf2;
  ena[148] = HAVE_floatunsv64hiv64df2;
  ena[149] = HAVE_floatunsv64siv64hf2;
  ena[150] = HAVE_floatunsv64siv64sf2;
  ena[151] = HAVE_floatunsv64siv64df2;
  ena[152] = HAVE_fix_trunchfhi2;
  ena[153] = HAVE_fix_trunchfsi2;
  ena[154] = HAVE_fix_truncsfhi2;
  ena[155] = HAVE_fix_truncsfsi2;
  ena[156] = HAVE_fix_truncdfhi2;
  ena[157] = HAVE_fix_truncdfsi2;
  ena[158] = HAVE_fix_truncv64hfv64hi2;
  ena[159] = HAVE_fix_truncv64hfv64si2;
  ena[160] = HAVE_fix_truncv64sfv64hi2;
  ena[161] = HAVE_fix_truncv64sfv64si2;
  ena[162] = HAVE_fix_truncv64dfv64hi2;
  ena[163] = HAVE_fix_truncv64dfv64si2;
  ena[164] = HAVE_fixuns_trunchfhi2;
  ena[165] = HAVE_fixuns_trunchfsi2;
  ena[166] = HAVE_fixuns_truncsfhi2;
  ena[167] = HAVE_fixuns_truncsfsi2;
  ena[168] = HAVE_fixuns_truncdfhi2;
  ena[169] = HAVE_fixuns_truncdfsi2;
  ena[170] = HAVE_fixuns_truncv64hfv64hi2;
  ena[171] = HAVE_fixuns_truncv64hfv64si2;
  ena[172] = HAVE_fixuns_truncv64sfv64hi2;
  ena[173] = HAVE_fixuns_truncv64sfv64si2;
  ena[174] = HAVE_fixuns_truncv64dfv64hi2;
  ena[175] = HAVE_fixuns_truncv64dfv64si2;
  ena[176] = HAVE_mulhisi3;
  ena[177] = HAVE_umulhisi3;
  ena[178] = HAVE_umulsidi3;
  ena[179] = HAVE_vcondv64qiv64qi;
  ena[180] = HAVE_vcondv64hiv64qi;
  ena[181] = HAVE_vcondv64siv64qi;
  ena[182] = HAVE_vcondv64div64qi;
  ena[183] = HAVE_vcondv64hfv64qi;
  ena[184] = HAVE_vcondv64sfv64qi;
  ena[185] = HAVE_vcondv64dfv64qi;
  ena[186] = HAVE_vcondv64qiv64hi;
  ena[187] = HAVE_vcondv64hiv64hi;
  ena[188] = HAVE_vcondv64siv64hi;
  ena[189] = HAVE_vcondv64div64hi;
  ena[190] = HAVE_vcondv64hfv64hi;
  ena[191] = HAVE_vcondv64sfv64hi;
  ena[192] = HAVE_vcondv64dfv64hi;
  ena[193] = HAVE_vcondv64qiv64si;
  ena[194] = HAVE_vcondv64hiv64si;
  ena[195] = HAVE_vcondv64siv64si;
  ena[196] = HAVE_vcondv64div64si;
  ena[197] = HAVE_vcondv64hfv64si;
  ena[198] = HAVE_vcondv64sfv64si;
  ena[199] = HAVE_vcondv64dfv64si;
  ena[200] = HAVE_vcondv64qiv64di;
  ena[201] = HAVE_vcondv64hiv64di;
  ena[202] = HAVE_vcondv64siv64di;
  ena[203] = HAVE_vcondv64div64di;
  ena[204] = HAVE_vcondv64hfv64di;
  ena[205] = HAVE_vcondv64sfv64di;
  ena[206] = HAVE_vcondv64dfv64di;
  ena[207] = HAVE_vcondv64qiv64hf;
  ena[208] = HAVE_vcondv64hiv64hf;
  ena[209] = HAVE_vcondv64siv64hf;
  ena[210] = HAVE_vcondv64div64hf;
  ena[211] = HAVE_vcondv64hfv64hf;
  ena[212] = HAVE_vcondv64sfv64hf;
  ena[213] = HAVE_vcondv64dfv64hf;
  ena[214] = HAVE_vcondv64qiv64sf;
  ena[215] = HAVE_vcondv64hiv64sf;
  ena[216] = HAVE_vcondv64siv64sf;
  ena[217] = HAVE_vcondv64div64sf;
  ena[218] = HAVE_vcondv64hfv64sf;
  ena[219] = HAVE_vcondv64sfv64sf;
  ena[220] = HAVE_vcondv64dfv64sf;
  ena[221] = HAVE_vcondv64qiv64df;
  ena[222] = HAVE_vcondv64hiv64df;
  ena[223] = HAVE_vcondv64siv64df;
  ena[224] = HAVE_vcondv64div64df;
  ena[225] = HAVE_vcondv64hfv64df;
  ena[226] = HAVE_vcondv64sfv64df;
  ena[227] = HAVE_vcondv64dfv64df;
  ena[228] = HAVE_vconduv64qiv64qi;
  ena[229] = HAVE_vconduv64hiv64qi;
  ena[230] = HAVE_vconduv64siv64qi;
  ena[231] = HAVE_vconduv64div64qi;
  ena[232] = HAVE_vconduv64hfv64qi;
  ena[233] = HAVE_vconduv64sfv64qi;
  ena[234] = HAVE_vconduv64dfv64qi;
  ena[235] = HAVE_vconduv64qiv64hi;
  ena[236] = HAVE_vconduv64hiv64hi;
  ena[237] = HAVE_vconduv64siv64hi;
  ena[238] = HAVE_vconduv64div64hi;
  ena[239] = HAVE_vconduv64hfv64hi;
  ena[240] = HAVE_vconduv64sfv64hi;
  ena[241] = HAVE_vconduv64dfv64hi;
  ena[242] = HAVE_vconduv64qiv64si;
  ena[243] = HAVE_vconduv64hiv64si;
  ena[244] = HAVE_vconduv64siv64si;
  ena[245] = HAVE_vconduv64div64si;
  ena[246] = HAVE_vconduv64hfv64si;
  ena[247] = HAVE_vconduv64sfv64si;
  ena[248] = HAVE_vconduv64dfv64si;
  ena[249] = HAVE_vconduv64qiv64di;
  ena[250] = HAVE_vconduv64hiv64di;
  ena[251] = HAVE_vconduv64siv64di;
  ena[252] = HAVE_vconduv64div64di;
  ena[253] = HAVE_vconduv64hfv64di;
  ena[254] = HAVE_vconduv64sfv64di;
  ena[255] = HAVE_vconduv64dfv64di;
  ena[256] = HAVE_vcond_mask_v64qidi;
  ena[257] = HAVE_vcond_mask_v64hidi;
  ena[258] = HAVE_vcond_mask_v64sidi;
  ena[259] = HAVE_vcond_mask_v64didi;
  ena[260] = HAVE_vcond_mask_v64hfdi;
  ena[261] = HAVE_vcond_mask_v64sfdi;
  ena[262] = HAVE_vcond_mask_v64dfdi;
  ena[263] = HAVE_vec_cmpv64qidi;
  ena[264] = HAVE_vec_cmpv64hidi;
  ena[265] = HAVE_vec_cmpv64sidi;
  ena[266] = HAVE_vec_cmpv64didi;
  ena[267] = HAVE_vec_cmpv64hfdi;
  ena[268] = HAVE_vec_cmpv64sfdi;
  ena[269] = HAVE_vec_cmpv64dfdi;
  ena[270] = HAVE_vec_cmpuv64qidi;
  ena[271] = HAVE_vec_cmpuv64hidi;
  ena[272] = HAVE_vec_cmpuv64sidi;
  ena[273] = HAVE_vec_cmpuv64didi;
  ena[274] = HAVE_maskloadv64qidi;
  ena[275] = HAVE_maskloadv64hidi;
  ena[276] = HAVE_maskloadv64sidi;
  ena[277] = HAVE_maskloadv64didi;
  ena[278] = HAVE_maskloadv64hfdi;
  ena[279] = HAVE_maskloadv64sfdi;
  ena[280] = HAVE_maskloadv64dfdi;
  ena[281] = HAVE_maskstorev64qidi;
  ena[282] = HAVE_maskstorev64hidi;
  ena[283] = HAVE_maskstorev64sidi;
  ena[284] = HAVE_maskstorev64didi;
  ena[285] = HAVE_maskstorev64hfdi;
  ena[286] = HAVE_maskstorev64sfdi;
  ena[287] = HAVE_maskstorev64dfdi;
  ena[288] = HAVE_gather_loadv64qiv64si;
  ena[289] = HAVE_gather_loadv64hiv64si;
  ena[290] = HAVE_gather_loadv64siv64si;
  ena[291] = HAVE_gather_loadv64div64si;
  ena[292] = HAVE_gather_loadv64hfv64si;
  ena[293] = HAVE_gather_loadv64sfv64si;
  ena[294] = HAVE_gather_loadv64dfv64si;
  ena[295] = HAVE_mask_gather_loadv64qiv64si;
  ena[296] = HAVE_mask_gather_loadv64hiv64si;
  ena[297] = HAVE_mask_gather_loadv64siv64si;
  ena[298] = HAVE_mask_gather_loadv64div64si;
  ena[299] = HAVE_mask_gather_loadv64hfv64si;
  ena[300] = HAVE_mask_gather_loadv64sfv64si;
  ena[301] = HAVE_mask_gather_loadv64dfv64si;
  ena[302] = HAVE_scatter_storev64qiv64si;
  ena[303] = HAVE_scatter_storev64hiv64si;
  ena[304] = HAVE_scatter_storev64siv64si;
  ena[305] = HAVE_scatter_storev64div64si;
  ena[306] = HAVE_scatter_storev64hfv64si;
  ena[307] = HAVE_scatter_storev64sfv64si;
  ena[308] = HAVE_scatter_storev64dfv64si;
  ena[309] = HAVE_mask_scatter_storev64qiv64si;
  ena[310] = HAVE_mask_scatter_storev64hiv64si;
  ena[311] = HAVE_mask_scatter_storev64siv64si;
  ena[312] = HAVE_mask_scatter_storev64div64si;
  ena[313] = HAVE_mask_scatter_storev64hfv64si;
  ena[314] = HAVE_mask_scatter_storev64sfv64si;
  ena[315] = HAVE_mask_scatter_storev64dfv64si;
  ena[316] = HAVE_vec_extractv64qiqi;
  ena[317] = HAVE_vec_extractv64hihi;
  ena[318] = HAVE_vec_extractv64sisi;
  ena[319] = HAVE_vec_extractv64didi;
  ena[320] = HAVE_vec_extractv64hfhf;
  ena[321] = HAVE_vec_extractv64sfsf;
  ena[322] = HAVE_vec_extractv64dfdf;
  ena[323] = HAVE_vec_initv64qiqi;
  ena[324] = HAVE_vec_initv64hihi;
  ena[325] = HAVE_vec_initv64sisi;
  ena[326] = HAVE_vec_initv64didi;
  ena[327] = HAVE_vec_initv64hfhf;
  ena[328] = HAVE_vec_initv64sfsf;
  ena[329] = HAVE_vec_initv64dfdf;
  ena[330] = HAVE_while_ultsidi;
  ena[331] = HAVE_addsi3;
  ena[332] = HAVE_adddi3;
  ena[333] = HAVE_addhf3;
  ena[334] = HAVE_addsf3;
  ena[335] = HAVE_adddf3;
  ena[336] = HAVE_addv64qi3;
  ena[337] = HAVE_addv64hi3;
  ena[338] = HAVE_addv64si3;
  ena[339] = HAVE_addv64di3;
  ena[340] = HAVE_addv64hf3;
  ena[341] = HAVE_addv64sf3;
  ena[342] = HAVE_addv64df3;
  ena[343] = HAVE_subsi3;
  ena[344] = HAVE_subdi3;
  ena[345] = HAVE_subhf3;
  ena[346] = HAVE_subsf3;
  ena[347] = HAVE_subdf3;
  ena[348] = HAVE_subv64qi3;
  ena[349] = HAVE_subv64hi3;
  ena[350] = HAVE_subv64si3;
  ena[351] = HAVE_subv64di3;
  ena[352] = HAVE_subv64hf3;
  ena[353] = HAVE_subv64sf3;
  ena[354] = HAVE_subv64df3;
  ena[355] = HAVE_mulsi3;
  ena[356] = HAVE_muldi3;
  ena[357] = HAVE_mulhf3;
  ena[358] = HAVE_mulsf3;
  ena[359] = HAVE_muldf3;
  ena[360] = HAVE_mulv64qi3;
  ena[361] = HAVE_mulv64hi3;
  ena[362] = HAVE_mulv64si3;
  ena[363] = HAVE_mulv64di3;
  ena[364] = HAVE_mulv64hf3;
  ena[365] = HAVE_mulv64sf3;
  ena[366] = HAVE_mulv64df3;
  ena[367] = HAVE_divhf3;
  ena[368] = HAVE_divsf3;
  ena[369] = HAVE_divdf3;
  ena[370] = HAVE_divv64hf3;
  ena[371] = HAVE_divv64sf3;
  ena[372] = HAVE_divv64df3;
  ena[373] = HAVE_andsi3;
  ena[374] = HAVE_anddi3;
  ena[375] = HAVE_andv64qi3;
  ena[376] = HAVE_andv64hi3;
  ena[377] = HAVE_andv64si3;
  ena[378] = HAVE_andv64di3;
  ena[379] = HAVE_iorsi3;
  ena[380] = HAVE_iordi3;
  ena[381] = HAVE_iorv64qi3;
  ena[382] = HAVE_iorv64hi3;
  ena[383] = HAVE_iorv64si3;
  ena[384] = HAVE_iorv64di3;
  ena[385] = HAVE_xorsi3;
  ena[386] = HAVE_xordi3;
  ena[387] = HAVE_xorv64qi3;
  ena[388] = HAVE_xorv64hi3;
  ena[389] = HAVE_xorv64si3;
  ena[390] = HAVE_xorv64di3;
  ena[391] = HAVE_ashlsi3;
  ena[392] = HAVE_ashldi3;
  ena[393] = HAVE_ashlti3;
  ena[394] = HAVE_ashlv64qi3;
  ena[395] = HAVE_ashlv64hi3;
  ena[396] = HAVE_ashlv64si3;
  ena[397] = HAVE_ashrsi3;
  ena[398] = HAVE_ashrdi3;
  ena[399] = HAVE_ashrti3;
  ena[400] = HAVE_ashrv64qi3;
  ena[401] = HAVE_ashrv64hi3;
  ena[402] = HAVE_ashrv64si3;
  ena[403] = HAVE_lshrsi3;
  ena[404] = HAVE_lshrdi3;
  ena[405] = HAVE_lshrti3;
  ena[406] = HAVE_lshrv64qi3;
  ena[407] = HAVE_lshrv64hi3;
  ena[408] = HAVE_lshrv64si3;
  ena[409] = HAVE_vashlv64qi3;
  ena[410] = HAVE_vashlv64hi3;
  ena[411] = HAVE_vashlv64si3;
  ena[412] = HAVE_vashrv64qi3;
  ena[413] = HAVE_vashrv64hi3;
  ena[414] = HAVE_vashrv64si3;
  ena[415] = HAVE_vlshrv64qi3;
  ena[416] = HAVE_vlshrv64hi3;
  ena[417] = HAVE_vlshrv64si3;
  ena[418] = HAVE_sminsi3;
  ena[419] = HAVE_sminhf3;
  ena[420] = HAVE_sminsf3;
  ena[421] = HAVE_smindf3;
  ena[422] = HAVE_sminv64qi3;
  ena[423] = HAVE_sminv64hi3;
  ena[424] = HAVE_sminv64si3;
  ena[425] = HAVE_sminv64hf3;
  ena[426] = HAVE_sminv64sf3;
  ena[427] = HAVE_sminv64df3;
  ena[428] = HAVE_smaxsi3;
  ena[429] = HAVE_smaxhf3;
  ena[430] = HAVE_smaxsf3;
  ena[431] = HAVE_smaxdf3;
  ena[432] = HAVE_smaxv64qi3;
  ena[433] = HAVE_smaxv64hi3;
  ena[434] = HAVE_smaxv64si3;
  ena[435] = HAVE_smaxv64hf3;
  ena[436] = HAVE_smaxv64sf3;
  ena[437] = HAVE_smaxv64df3;
  ena[438] = HAVE_uminsi3;
  ena[439] = HAVE_uminv64qi3;
  ena[440] = HAVE_uminv64hi3;
  ena[441] = HAVE_uminv64si3;
  ena[442] = HAVE_umaxsi3;
  ena[443] = HAVE_umaxv64qi3;
  ena[444] = HAVE_umaxv64hi3;
  ena[445] = HAVE_umaxv64si3;
  ena[446] = HAVE_negv64hf2;
  ena[447] = HAVE_negv64sf2;
  ena[448] = HAVE_negv64df2;
  ena[449] = HAVE_abshf2;
  ena[450] = HAVE_abssf2;
  ena[451] = HAVE_absdf2;
  ena[452] = HAVE_absv64hf2;
  ena[453] = HAVE_absv64sf2;
  ena[454] = HAVE_absv64df2;
  ena[455] = HAVE_one_cmplsi2;
  ena[456] = HAVE_one_cmplv64qi2;
  ena[457] = HAVE_one_cmplv64hi2;
  ena[458] = HAVE_one_cmplv64si2;
  ena[459] = HAVE_clzsi2;
  ena[460] = HAVE_clzdi2;
  ena[461] = HAVE_ctzsi2;
  ena[462] = HAVE_ctzdi2;
  ena[463] = HAVE_clrsbsi2;
  ena[464] = HAVE_clrsbdi2;
  ena[465] = HAVE_popcountsi2;
  ena[466] = HAVE_popcountv64qi2;
  ena[467] = HAVE_popcountv64hi2;
  ena[468] = HAVE_popcountv64si2;
  ena[469] = HAVE_sqrthf2;
  ena[470] = HAVE_sqrtsf2;
  ena[471] = HAVE_sqrtdf2;
  ena[472] = HAVE_sqrtv64hf2;
  ena[473] = HAVE_sqrtv64sf2;
  ena[474] = HAVE_sqrtv64df2;
  ena[475] = HAVE_sync_compare_and_swapsi;
  ena[476] = HAVE_sync_compare_and_swapdi;
  ena[477] = HAVE_movbi;
  ena[478] = HAVE_movqi;
  ena[479] = HAVE_movhi;
  ena[480] = HAVE_movsi;
  ena[481] = HAVE_movdi;
  ena[482] = HAVE_movti;
  ena[483] = HAVE_movsf;
  ena[484] = HAVE_movdf;
  ena[485] = HAVE_movv64qi;
  ena[486] = HAVE_movv64hi;
  ena[487] = HAVE_movv64si;
  ena[488] = HAVE_movv64di;
  ena[489] = HAVE_movv64hf;
  ena[490] = HAVE_movv64sf;
  ena[491] = HAVE_movv64df;
  ena[492] = HAVE_reload_inv64qi;
  ena[493] = HAVE_reload_inv64hi;
  ena[494] = HAVE_reload_inv64si;
  ena[495] = HAVE_reload_inv64di;
  ena[496] = HAVE_reload_inv64hf;
  ena[497] = HAVE_reload_inv64sf;
  ena[498] = HAVE_reload_inv64df;
  ena[499] = HAVE_reload_outv64qi;
  ena[500] = HAVE_reload_outv64hi;
  ena[501] = HAVE_reload_outv64si;
  ena[502] = HAVE_reload_outv64di;
  ena[503] = HAVE_reload_outv64hf;
  ena[504] = HAVE_reload_outv64sf;
  ena[505] = HAVE_reload_outv64df;
  ena[506] = HAVE_cbranchsi4;
  ena[507] = HAVE_cbranchdi4;
  ena[508] = HAVE_cbranchsf4;
  ena[509] = HAVE_cbranchdf4;
  ena[510] = HAVE_cond_addv64qi;
  ena[511] = HAVE_cond_addv64hi;
  ena[512] = HAVE_cond_addv64si;
  ena[513] = HAVE_cond_addv64di;
  ena[514] = HAVE_cond_addv64hf;
  ena[515] = HAVE_cond_addv64sf;
  ena[516] = HAVE_cond_addv64df;
  ena[517] = HAVE_cond_subv64qi;
  ena[518] = HAVE_cond_subv64hi;
  ena[519] = HAVE_cond_subv64si;
  ena[520] = HAVE_cond_subv64di;
  ena[521] = HAVE_cond_subv64hf;
  ena[522] = HAVE_cond_subv64sf;
  ena[523] = HAVE_cond_subv64df;
  ena[524] = HAVE_cond_mulv64qi;
  ena[525] = HAVE_cond_mulv64hi;
  ena[526] = HAVE_cond_mulv64si;
  ena[527] = HAVE_cond_mulv64di;
  ena[528] = HAVE_cond_mulv64hf;
  ena[529] = HAVE_cond_mulv64sf;
  ena[530] = HAVE_cond_mulv64df;
  ena[531] = HAVE_cond_andv64qi;
  ena[532] = HAVE_cond_andv64hi;
  ena[533] = HAVE_cond_andv64si;
  ena[534] = HAVE_cond_andv64di;
  ena[535] = HAVE_cond_iorv64qi;
  ena[536] = HAVE_cond_iorv64hi;
  ena[537] = HAVE_cond_iorv64si;
  ena[538] = HAVE_cond_iorv64di;
  ena[539] = HAVE_cond_xorv64qi;
  ena[540] = HAVE_cond_xorv64hi;
  ena[541] = HAVE_cond_xorv64si;
  ena[542] = HAVE_cond_xorv64di;
  ena[543] = HAVE_cstoresi4;
  ena[544] = HAVE_cstoredi4;
  ena[545] = HAVE_cstoresf4;
  ena[546] = HAVE_cstoredf4;
  ena[547] = HAVE_addptrdi3;
  ena[548] = HAVE_smulsi3_highpart;
  ena[549] = HAVE_smulv64si3_highpart;
  ena[550] = HAVE_umulsi3_highpart;
  ena[551] = HAVE_umulv64si3_highpart;
  ena[552] = HAVE_fmahf4;
  ena[553] = HAVE_fmasf4;
  ena[554] = HAVE_fmadf4;
  ena[555] = HAVE_fmav64hf4;
  ena[556] = HAVE_fmav64sf4;
  ena[557] = HAVE_fmav64df4;
  ena[558] = HAVE_reduc_smax_scal_v64qi;
  ena[559] = HAVE_reduc_smax_scal_v64hi;
  ena[560] = HAVE_reduc_smax_scal_v64si;
  ena[561] = HAVE_reduc_smax_scal_v64di;
  ena[562] = HAVE_reduc_smax_scal_v64hf;
  ena[563] = HAVE_reduc_smax_scal_v64sf;
  ena[564] = HAVE_reduc_smax_scal_v64df;
  ena[565] = HAVE_reduc_smin_scal_v64qi;
  ena[566] = HAVE_reduc_smin_scal_v64hi;
  ena[567] = HAVE_reduc_smin_scal_v64si;
  ena[568] = HAVE_reduc_smin_scal_v64di;
  ena[569] = HAVE_reduc_smin_scal_v64hf;
  ena[570] = HAVE_reduc_smin_scal_v64sf;
  ena[571] = HAVE_reduc_smin_scal_v64df;
  ena[572] = HAVE_reduc_plus_scal_v64qi;
  ena[573] = HAVE_reduc_plus_scal_v64hi;
  ena[574] = HAVE_reduc_plus_scal_v64si;
  ena[575] = HAVE_reduc_plus_scal_v64di;
  ena[576] = HAVE_reduc_plus_scal_v64hf;
  ena[577] = HAVE_reduc_plus_scal_v64sf;
  ena[578] = HAVE_reduc_plus_scal_v64df;
  ena[579] = HAVE_reduc_umax_scal_v64qi;
  ena[580] = HAVE_reduc_umax_scal_v64hi;
  ena[581] = HAVE_reduc_umax_scal_v64si;
  ena[582] = HAVE_reduc_umax_scal_v64di;
  ena[583] = HAVE_reduc_umax_scal_v64hf;
  ena[584] = HAVE_reduc_umax_scal_v64sf;
  ena[585] = HAVE_reduc_umax_scal_v64df;
  ena[586] = HAVE_reduc_umin_scal_v64qi;
  ena[587] = HAVE_reduc_umin_scal_v64hi;
  ena[588] = HAVE_reduc_umin_scal_v64si;
  ena[589] = HAVE_reduc_umin_scal_v64di;
  ena[590] = HAVE_reduc_umin_scal_v64hf;
  ena[591] = HAVE_reduc_umin_scal_v64sf;
  ena[592] = HAVE_reduc_umin_scal_v64df;
  ena[593] = HAVE_reduc_and_scal_v64qi;
  ena[594] = HAVE_reduc_and_scal_v64hi;
  ena[595] = HAVE_reduc_and_scal_v64si;
  ena[596] = HAVE_reduc_and_scal_v64di;
  ena[597] = HAVE_reduc_and_scal_v64hf;
  ena[598] = HAVE_reduc_and_scal_v64sf;
  ena[599] = HAVE_reduc_and_scal_v64df;
  ena[600] = HAVE_reduc_ior_scal_v64qi;
  ena[601] = HAVE_reduc_ior_scal_v64hi;
  ena[602] = HAVE_reduc_ior_scal_v64si;
  ena[603] = HAVE_reduc_ior_scal_v64di;
  ena[604] = HAVE_reduc_ior_scal_v64hf;
  ena[605] = HAVE_reduc_ior_scal_v64sf;
  ena[606] = HAVE_reduc_ior_scal_v64df;
  ena[607] = HAVE_reduc_xor_scal_v64qi;
  ena[608] = HAVE_reduc_xor_scal_v64hi;
  ena[609] = HAVE_reduc_xor_scal_v64si;
  ena[610] = HAVE_reduc_xor_scal_v64di;
  ena[611] = HAVE_reduc_xor_scal_v64hf;
  ena[612] = HAVE_reduc_xor_scal_v64sf;
  ena[613] = HAVE_reduc_xor_scal_v64df;
  ena[614] = HAVE_fold_left_plus_v64hf;
  ena[615] = HAVE_fold_left_plus_v64sf;
  ena[616] = HAVE_fold_left_plus_v64df;
  ena[617] = HAVE_extract_last_v64qi;
  ena[618] = HAVE_extract_last_v64hi;
  ena[619] = HAVE_extract_last_v64si;
  ena[620] = HAVE_extract_last_v64di;
  ena[621] = HAVE_extract_last_v64hf;
  ena[622] = HAVE_extract_last_v64sf;
  ena[623] = HAVE_extract_last_v64df;
  ena[624] = HAVE_fold_extract_last_v64qi;
  ena[625] = HAVE_fold_extract_last_v64hi;
  ena[626] = HAVE_fold_extract_last_v64si;
  ena[627] = HAVE_fold_extract_last_v64di;
  ena[628] = HAVE_fold_extract_last_v64hf;
  ena[629] = HAVE_fold_extract_last_v64sf;
  ena[630] = HAVE_fold_extract_last_v64df;
  ena[631] = HAVE_vec_setv64qi;
  ena[632] = HAVE_vec_setv64hi;
  ena[633] = HAVE_vec_setv64si;
  ena[634] = HAVE_vec_setv64di;
  ena[635] = HAVE_vec_setv64hf;
  ena[636] = HAVE_vec_setv64sf;
  ena[637] = HAVE_vec_setv64df;
  ena[638] = HAVE_atomic_exchangesi;
  ena[639] = HAVE_atomic_exchangedi;
  ena[640] = HAVE_atomic_loadsi;
  ena[641] = HAVE_atomic_loaddi;
  ena[642] = HAVE_atomic_storesi;
  ena[643] = HAVE_atomic_storedi;
  ena[644] = HAVE_vec_duplicatev64qi;
  ena[645] = HAVE_vec_duplicatev64hi;
  ena[646] = HAVE_vec_duplicatev64si;
  ena[647] = HAVE_vec_duplicatev64di;
  ena[648] = HAVE_vec_duplicatev64hf;
  ena[649] = HAVE_vec_duplicatev64sf;
  ena[650] = HAVE_vec_duplicatev64df;
  ena[651] = HAVE_vec_seriesv64si;
  ena[652] = HAVE_vec_seriesv64di;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab or len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return HAVE_while_ultsidi;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

